/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/common_msgs/actionlib_msgs/msg/GoalStatus.msg.  Do not edit! */
#ifndef ACTIONLIB_MSGS_GOALSTATUS_H
#define ACTIONLIB_MSGS_GOALSTATUS_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "actionlib_msgs/GoalID.h"

namespace actionlib_msgs
{

//! \htmlinclude GoalStatus.msg.html

class GoalStatus : public ros::Message
{
public:
  typedef boost::shared_ptr<GoalStatus> Ptr;
  typedef boost::shared_ptr<GoalStatus const> ConstPtr;

  typedef actionlib_msgs::GoalID _goal_id_type;
  typedef uint8_t _status_type;
  typedef std::string _text_type;

  actionlib_msgs::GoalID goal_id;
  uint8_t status;
  const static uint8_t PENDING = 0;
  const static uint8_t ACTIVE = 1;
  const static uint8_t PREEMPTED = 2;
  const static uint8_t SUCCEEDED = 3;
  const static uint8_t ABORTED = 4;
  const static uint8_t REJECTED = 5;
  const static uint8_t PREEMPTING = 6;
  const static uint8_t RECALLING = 7;
  const static uint8_t RECALLED = 8;
  const static uint8_t LOST = 9;
  std::string text;

  GoalStatus() : ros::Message(),
    status(0)
  {
  }
  GoalStatus(const GoalStatus &copy) : ros::Message(),
    goal_id(copy.goal_id),
    status(copy.status),
    text(copy.text)
  {
    (void)copy;
  }
  GoalStatus &operator =(const GoalStatus &copy)
  {
    if (this == &copy)
      return *this;
    goal_id = copy.goal_id;
    status = copy.status;
    text = copy.text;
    return *this;
  }
  virtual ~GoalStatus() 
  {
  }
  inline static std::string __s_getDataType() { return std::string("actionlib_msgs/GoalStatus"); }
  inline static std::string __s_getMD5Sum() { return std::string("d388f9b87b3c471f784434d671988d4a"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "GoalID goal_id\n"
    "uint8 status\n"
    "uint8 PENDING         = 0   # The goal has yet to be processed by the action server\n"
    "uint8 ACTIVE          = 1   # The goal is currently being processed by the action server\n"
    "uint8 PREEMPTED       = 2   # The goal received a cancel request after it started executing\n"
    "                            #   and has since completed its execution (Terminal State)\n"
    "uint8 SUCCEEDED       = 3   # The goal was achieved successfully by the action server (Terminal State)\n"
    "uint8 ABORTED         = 4   # The goal was aborted during execution by the action server due\n"
    "                            #    to some failure (Terminal State)\n"
    "uint8 REJECTED        = 5   # The goal was rejected by the action server without being processed,\n"
    "                            #    because the goal was unattainable or invalid (Terminal State)\n"
    "uint8 PREEMPTING      = 6   # The goal received a cancel request after it started executing\n"
    "                            #    and has not yet completed execution\n"
    "uint8 RECALLING       = 7   # The goal received a cancel request before it started executing,\n"
    "                            #    but the action server has not yet confirmed that the goal is canceled\n"
    "uint8 RECALLED        = 8   # The goal received a cancel request before it started executing\n"
    "                            #    and was successfully cancelled (Terminal State)\n"
    "uint8 LOST            = 9   # An action client can determine that a goal is LOST. This should not be\n"
    "                            #    sent over the wire by an action server\n"
    "\n"
    "#Allow for the user to associate a string with GoalStatus for debugging\n"
    "string text\n"
    "\n"
    "\n"
    "================================================================================\n"
    "MSG: actionlib_msgs/GoalID\n"
    "# The stamp should store the time at which this goal was requested.\n"
    "# It is used by an action server when it tries to preempt all\n"
    "# goals that were requested before a certain time\n"
    "time stamp\n"
    "\n"
    "# The id provides a way to associate feedback and\n"
    "# result message with specific goal requests. The id\n"
    "# specified must be unique.\n"
    "string id\n"
    "\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += goal_id.serializationLength(); // goal_id
    __l += 1; // status
    __l += 0; // PENDING
    __l += 0; // ACTIVE
    __l += 0; // PREEMPTED
    __l += 0; // SUCCEEDED
    __l += 0; // ABORTED
    __l += 0; // REJECTED
    __l += 0; // PREEMPTING
    __l += 0; // RECALLING
    __l += 0; // RECALLED
    __l += 0; // LOST
    __l += 4 + text.length(); // text
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    write_ptr = goal_id.serialize(write_ptr, seq);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, status);
    unsigned __ros_text_len = text.length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_text_len);
    SROS_SERIALIZE_BUFFER(write_ptr, text.c_str(), __ros_text_len);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    read_ptr = goal_id.deserialize(read_ptr);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, status);
    unsigned __ros_text_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_text_len);
    text = std::string((const char *)read_ptr, __ros_text_len);
    read_ptr += __ros_text_len;
    return read_ptr;
  }
};

typedef boost::shared_ptr<GoalStatus> GoalStatusPtr;
typedef boost::shared_ptr<GoalStatus const> GoalStatusConstPtr;


}

#endif
