/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/common_msgs/actionlib_msgs/msg/GoalStatusArray.msg.  Do not edit! */
#ifndef ACTIONLIB_MSGS_GOALSTATUSARRAY_H
#define ACTIONLIB_MSGS_GOALSTATUSARRAY_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "roslib/Header.h"
#include "actionlib_msgs/GoalID.h"
#include "actionlib_msgs/GoalStatus.h"

namespace actionlib_msgs
{

//! \htmlinclude GoalStatusArray.msg.html

class GoalStatusArray : public ros::Message
{
public:
  typedef boost::shared_ptr<GoalStatusArray> Ptr;
  typedef boost::shared_ptr<GoalStatusArray const> ConstPtr;

  typedef roslib::Header _header_type;
  typedef std::vector<actionlib_msgs::GoalStatus> _status_list_type;

  roslib::Header header;
  std::vector<actionlib_msgs::GoalStatus> status_list;

  GoalStatusArray() : ros::Message()
  {
  }
  GoalStatusArray(const GoalStatusArray &copy) : ros::Message(),
    header(copy.header)
  {
    (void)copy;
    status_list = copy.status_list;
  }
  GoalStatusArray &operator =(const GoalStatusArray &copy)
  {
    if (this == &copy)
      return *this;
    status_list.clear();
    header = copy.header;
    status_list = copy.status_list;
    return *this;
  }
  virtual ~GoalStatusArray() 
  {
    status_list.clear();
  }
  inline static std::string __s_getDataType() { return std::string("actionlib_msgs/GoalStatusArray"); }
  inline static std::string __s_getMD5Sum() { return std::string("8b2b82f13216d0a8ea88bd3af735e619"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# Stores the statuses for goals that are currently being tracked\n"
    "# by an action server\n"
    "Header header\n"
    "GoalStatus[] status_list\n"
    "\n"
    "\n"
    "================================================================================\n"
    "MSG: roslib/Header\n"
    "# Standard metadata for higher-level stamped data types.\n"
    "# This is generally used to communicate timestamped data \n"
    "# in a particular coordinate frame.\n"
    "# \n"
    "# sequence ID: consecutively increasing ID \n"
    "uint32 seq\n"
    "#Two-integer timestamp that is expressed as:\n"
    "# * stamp.secs: seconds (stamp_secs) since epoch\n"
    "# * stamp.nsecs: nanoseconds since stamp_secs\n"
    "# time-handling sugar is provided by the client library\n"
    "time stamp\n"
    "#Frame this data is associated with\n"
    "# 0: no frame\n"
    "# 1: global frame\n"
    "string frame_id\n"
    "\n"
    "================================================================================\n"
    "MSG: actionlib_msgs/GoalStatus\n"
    "GoalID goal_id\n"
    "uint8 status\n"
    "uint8 PENDING         = 0   # The goal has yet to be processed by the action server\n"
    "uint8 ACTIVE          = 1   # The goal is currently being processed by the action server\n"
    "uint8 PREEMPTED       = 2   # The goal received a cancel request after it started executing\n"
    "                            #   and has since completed its execution (Terminal State)\n"
    "uint8 SUCCEEDED       = 3   # The goal was achieved successfully by the action server (Terminal State)\n"
    "uint8 ABORTED         = 4   # The goal was aborted during execution by the action server due\n"
    "                            #    to some failure (Terminal State)\n"
    "uint8 REJECTED        = 5   # The goal was rejected by the action server without being processed,\n"
    "                            #    because the goal was unattainable or invalid (Terminal State)\n"
    "uint8 PREEMPTING      = 6   # The goal received a cancel request after it started executing\n"
    "                            #    and has not yet completed execution\n"
    "uint8 RECALLING       = 7   # The goal received a cancel request before it started executing,\n"
    "                            #    but the action server has not yet confirmed that the goal is canceled\n"
    "uint8 RECALLED        = 8   # The goal received a cancel request before it started executing\n"
    "                            #    and was successfully cancelled (Terminal State)\n"
    "uint8 LOST            = 9   # An action client can determine that a goal is LOST. This should not be\n"
    "                            #    sent over the wire by an action server\n"
    "\n"
    "#Allow for the user to associate a string with GoalStatus for debugging\n"
    "string text\n"
    "\n"
    "\n"
    "================================================================================\n"
    "MSG: actionlib_msgs/GoalID\n"
    "# The stamp should store the time at which this goal was requested.\n"
    "# It is used by an action server when it tries to preempt all\n"
    "# goals that were requested before a certain time\n"
    "time stamp\n"
    "\n"
    "# The id provides a way to associate feedback and\n"
    "# result message with specific goal requests. The id\n"
    "# specified must be unique.\n"
    "string id\n"
    "\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  void set_status_list_size(uint32_t __ros_new_size)
  {
    this->status_list.resize(__ros_new_size);
  }
  inline uint32_t get_status_list_size() const { return status_list.size(); }
  uint32_t calc_status_list_array_serialization_len() const
  {
    uint32_t l = 0;
    uint32_t status_list_size = status_list.size();
    for (size_t i = 0; i < status_list_size; i++)
      l += status_list[i].serializationLength();
    return l;
  }
  inline void get_status_list_vec (std::vector<actionlib_msgs::GoalStatus> &__ros_vec) const
  {
    __ros_vec = this->status_list;
  }
  inline void set_status_list_vec(const std::vector<actionlib_msgs::GoalStatus> &__ros_vec)
  {
    this->status_list = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += header.serializationLength(); // header
    __l += 4 + calc_status_list_array_serialization_len(); // status_list
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
                             uint32_t seq) const
  {
    roslib::Header _ser_header = header;
    bool __reset_seq = (header.seq == 0);
    if (__reset_seq) _ser_header.seq = seq;
    write_ptr = _ser_header.serialize(write_ptr, seq);
    uint32_t __status_list_size = status_list.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __status_list_size);
    for (size_t i = 0; i < __status_list_size; i++)
      write_ptr = status_list[i].serialize(write_ptr, seq);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    read_ptr = header.deserialize(read_ptr);
    uint32_t __status_list_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __status_list_size);
    set_status_list_size(__status_list_size);
    for (size_t i = 0; i < __status_list_size; i++)
      read_ptr = status_list[i].deserialize(read_ptr);
    return read_ptr;
  }
};

typedef boost::shared_ptr<GoalStatusArray> GoalStatusArrayPtr;
typedef boost::shared_ptr<GoalStatusArray const> GoalStatusArrayConstPtr;


}

#endif
