# autogenerated by genmsg_py from GoalStatus.msg. Do not edit.
import roslib.message
import struct

import roslib.rostime
import actionlib_msgs.msg

class GoalStatus(roslib.message.Message):
  _md5sum = "d388f9b87b3c471f784434d671988d4a"
  _type = "actionlib_msgs/GoalStatus"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """GoalID goal_id
uint8 status
uint8 PENDING         = 0   # The goal has yet to be processed by the action server
uint8 ACTIVE          = 1   # The goal is currently being processed by the action server
uint8 PREEMPTED       = 2   # The goal received a cancel request after it started executing
                            #   and has since completed its execution (Terminal State)
uint8 SUCCEEDED       = 3   # The goal was achieved successfully by the action server (Terminal State)
uint8 ABORTED         = 4   # The goal was aborted during execution by the action server due
                            #    to some failure (Terminal State)
uint8 REJECTED        = 5   # The goal was rejected by the action server without being processed,
                            #    because the goal was unattainable or invalid (Terminal State)
uint8 PREEMPTING      = 6   # The goal received a cancel request after it started executing
                            #    and has not yet completed execution
uint8 RECALLING       = 7   # The goal received a cancel request before it started executing,
                            #    but the action server has not yet confirmed that the goal is canceled
uint8 RECALLED        = 8   # The goal received a cancel request before it started executing
                            #    and was successfully cancelled (Terminal State)
uint8 LOST            = 9   # An action client can determine that a goal is LOST. This should not be
                            #    sent over the wire by an action server

#Allow for the user to associate a string with GoalStatus for debugging
string text


================================================================================
MSG: actionlib_msgs/GoalID
# The stamp should store the time at which this goal was requested.
# It is used by an action server when it tries to preempt all
# goals that were requested before a certain time
time stamp

# The id provides a way to associate feedback and
# result message with specific goal requests. The id
# specified must be unique.
string id


"""
  # Pseudo-constants
  PENDING = 0
  ACTIVE = 1
  PREEMPTED = 2
  SUCCEEDED = 3
  ABORTED = 4
  REJECTED = 5
  PREEMPTING = 6
  RECALLING = 7
  RECALLED = 8
  LOST = 9

  __slots__ = ['goal_id','status','text']
  _slot_types = ['actionlib_msgs/GoalID','uint8','string']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   goal_id,status,text
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(GoalStatus, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.goal_id is None:
        self.goal_id = actionlib_msgs.msg.GoalID()
      if self.status is None:
        self.status = 0
      if self.text is None:
        self.text = ''
    else:
      self.goal_id = actionlib_msgs.msg.GoalID()
      self.status = 0
      self.text = ''

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      buff.write(struct.pack('<2I', self.goal_id.stamp.secs, self.goal_id.stamp.nsecs))
      length = len(self.goal_id.id)
      #serialize self.goal_id.id
      buff.write(struct.pack('<I%ss'%length, length, self.goal_id.id))
      buff.write(struct.pack('<B', self.status))
      length = len(self.text)
      #serialize self.text
      buff.write(struct.pack('<I%ss'%length, length, self.text))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.goal_id is None:
        self.goal_id = actionlib_msgs.msg.GoalID()
      end = 0
      start = end
      end += 8
      (self.goal_id.stamp.secs, self.goal_id.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.goal_id.id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.goal_id.id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 1
      (self.status,) = struct.unpack('<B',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.text
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.text,) = struct.unpack(pattern, str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      buff.write(struct.pack('<2I', self.goal_id.stamp.secs, self.goal_id.stamp.nsecs))
      length = len(self.goal_id.id)
      #serialize self.goal_id.id
      buff.write(struct.pack('<I%ss'%length, length, self.goal_id.id))
      buff.write(struct.pack('<B', self.status))
      length = len(self.text)
      #serialize self.text
      buff.write(struct.pack('<I%ss'%length, length, self.text))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.goal_id is None:
        self.goal_id = actionlib_msgs.msg.GoalID()
      end = 0
      start = end
      end += 8
      (self.goal_id.stamp.secs, self.goal_id.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.goal_id.id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.goal_id.id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 1
      (self.status,) = struct.unpack('<B',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.text
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.text,) = struct.unpack(pattern, str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

