/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/common_msgs/diagnostic_msgs/msg/DiagnosticArray.msg.  Do not edit! */
#ifndef DIAGNOSTIC_MSGS_DIAGNOSTICARRAY_H
#define DIAGNOSTIC_MSGS_DIAGNOSTICARRAY_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "roslib/Header.h"
#include "diagnostic_msgs/KeyValue.h"
#include "diagnostic_msgs/DiagnosticStatus.h"

namespace diagnostic_msgs
{

//! \htmlinclude DiagnosticArray.msg.html

class DiagnosticArray : public ros::Message
{
public:
  typedef boost::shared_ptr<DiagnosticArray> Ptr;
  typedef boost::shared_ptr<DiagnosticArray const> ConstPtr;

  typedef roslib::Header _header_type;
  typedef std::vector<diagnostic_msgs::DiagnosticStatus> _status_type;

  roslib::Header header;
  std::vector<diagnostic_msgs::DiagnosticStatus> status;

  DiagnosticArray() : ros::Message()
  {
  }
  DiagnosticArray(const DiagnosticArray &copy) : ros::Message(),
    header(copy.header)
  {
    (void)copy;
    status = copy.status;
  }
  DiagnosticArray &operator =(const DiagnosticArray &copy)
  {
    if (this == &copy)
      return *this;
    status.clear();
    header = copy.header;
    status = copy.status;
    return *this;
  }
  virtual ~DiagnosticArray() 
  {
    status.clear();
  }
  inline static std::string __s_getDataType() { return std::string("diagnostic_msgs/DiagnosticArray"); }
  inline static std::string __s_getMD5Sum() { return std::string("3cfbeff055e708a24c3d946a5c8139cd"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# This message is used to send diagnostic information about the state of the robot\n"
    "Header header #for timestamp\n"
    "DiagnosticStatus[] status # an array of components being reported on\n"
    "================================================================================\n"
    "MSG: roslib/Header\n"
    "# Standard metadata for higher-level stamped data types.\n"
    "# This is generally used to communicate timestamped data \n"
    "# in a particular coordinate frame.\n"
    "# \n"
    "# sequence ID: consecutively increasing ID \n"
    "uint32 seq\n"
    "#Two-integer timestamp that is expressed as:\n"
    "# * stamp.secs: seconds (stamp_secs) since epoch\n"
    "# * stamp.nsecs: nanoseconds since stamp_secs\n"
    "# time-handling sugar is provided by the client library\n"
    "time stamp\n"
    "#Frame this data is associated with\n"
    "# 0: no frame\n"
    "# 1: global frame\n"
    "string frame_id\n"
    "\n"
    "================================================================================\n"
    "MSG: diagnostic_msgs/DiagnosticStatus\n"
    "# This message holds the status of an individual component of the robot.\n"
    "# \n"
    "\n"
    "# Possible levels of operations\n"
    "byte OK=0\n"
    "byte WARN=1\n"
    "byte ERROR=2\n"
    "\n"
    "byte level # level of operation enumerated above \n"
    "string name # a description of the test/component reporting\n"
    "string message # a description of the status\n"
    "string hardware_id # a hardware unique string\n"
    "KeyValue[] values # an array of values associated with the status\n"
    "\n"
    "\n"
    "================================================================================\n"
    "MSG: diagnostic_msgs/KeyValue\n"
    "string key # what to label this value when viewing\n"
    "string value # a value to track over time\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  void set_status_size(uint32_t __ros_new_size)
  {
    this->status.resize(__ros_new_size);
  }
  inline uint32_t get_status_size() const { return status.size(); }
  uint32_t calc_status_array_serialization_len() const
  {
    uint32_t l = 0;
    uint32_t status_size = status.size();
    for (size_t i = 0; i < status_size; i++)
      l += status[i].serializationLength();
    return l;
  }
  inline void get_status_vec (std::vector<diagnostic_msgs::DiagnosticStatus> &__ros_vec) const
  {
    __ros_vec = this->status;
  }
  inline void set_status_vec(const std::vector<diagnostic_msgs::DiagnosticStatus> &__ros_vec)
  {
    this->status = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += header.serializationLength(); // header
    __l += 4 + calc_status_array_serialization_len(); // status
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
                             uint32_t seq) const
  {
    roslib::Header _ser_header = header;
    bool __reset_seq = (header.seq == 0);
    if (__reset_seq) _ser_header.seq = seq;
    write_ptr = _ser_header.serialize(write_ptr, seq);
    uint32_t __status_size = status.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __status_size);
    for (size_t i = 0; i < __status_size; i++)
      write_ptr = status[i].serialize(write_ptr, seq);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    read_ptr = header.deserialize(read_ptr);
    uint32_t __status_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __status_size);
    set_status_size(__status_size);
    for (size_t i = 0; i < __status_size; i++)
      read_ptr = status[i].deserialize(read_ptr);
    return read_ptr;
  }
};

typedef boost::shared_ptr<DiagnosticArray> DiagnosticArrayPtr;
typedef boost::shared_ptr<DiagnosticArray const> DiagnosticArrayConstPtr;


}

#endif
