/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/common_msgs/diagnostic_msgs/msg/DiagnosticStatus.msg.  Do not edit! */
#ifndef DIAGNOSTIC_MSGS_DIAGNOSTICSTATUS_H
#define DIAGNOSTIC_MSGS_DIAGNOSTICSTATUS_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "diagnostic_msgs/KeyValue.h"

namespace diagnostic_msgs
{

//! \htmlinclude DiagnosticStatus.msg.html

class DiagnosticStatus : public ros::Message
{
public:
  typedef boost::shared_ptr<DiagnosticStatus> Ptr;
  typedef boost::shared_ptr<DiagnosticStatus const> ConstPtr;

  typedef int8_t _level_type;
  typedef std::string _name_type;
  typedef std::string _message_type;
  typedef std::string _hardware_id_type;
  typedef std::vector<diagnostic_msgs::KeyValue> _values_type;

  const static int8_t OK = 0;
  const static int8_t WARN = 1;
  const static int8_t ERROR = 2;
  int8_t level;
  std::string name;
  std::string message;
  std::string hardware_id;
  std::vector<diagnostic_msgs::KeyValue> values;

  DiagnosticStatus() : ros::Message(),
    level(0)
  {
  }
  DiagnosticStatus(const DiagnosticStatus &copy) : ros::Message(),
    level(copy.level),
    name(copy.name),
    message(copy.message),
    hardware_id(copy.hardware_id)
  {
    (void)copy;
    values = copy.values;
  }
  DiagnosticStatus &operator =(const DiagnosticStatus &copy)
  {
    if (this == &copy)
      return *this;
    values.clear();
    level = copy.level;
    name = copy.name;
    message = copy.message;
    hardware_id = copy.hardware_id;
    values = copy.values;
    return *this;
  }
  virtual ~DiagnosticStatus() 
  {
    values.clear();
  }
  inline static std::string __s_getDataType() { return std::string("diagnostic_msgs/DiagnosticStatus"); }
  inline static std::string __s_getMD5Sum() { return std::string("67d15a62edb26e9d52b0f0efa3ef9da7"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# This message holds the status of an individual component of the robot.\n"
    "# \n"
    "\n"
    "# Possible levels of operations\n"
    "byte OK=0\n"
    "byte WARN=1\n"
    "byte ERROR=2\n"
    "\n"
    "byte level # level of operation enumerated above \n"
    "string name # a description of the test/component reporting\n"
    "string message # a description of the status\n"
    "string hardware_id # a hardware unique string\n"
    "KeyValue[] values # an array of values associated with the status\n"
    "\n"
    "\n"
    "================================================================================\n"
    "MSG: diagnostic_msgs/KeyValue\n"
    "string key # what to label this value when viewing\n"
    "string value # a value to track over time\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  void set_values_size(uint32_t __ros_new_size)
  {
    this->values.resize(__ros_new_size);
  }
  inline uint32_t get_values_size() const { return values.size(); }
  uint32_t calc_values_array_serialization_len() const
  {
    uint32_t l = 0;
    uint32_t values_size = values.size();
    for (size_t i = 0; i < values_size; i++)
      l += values[i].serializationLength();
    return l;
  }
  inline void get_values_vec (std::vector<diagnostic_msgs::KeyValue> &__ros_vec) const
  {
    __ros_vec = this->values;
  }
  inline void set_values_vec(const std::vector<diagnostic_msgs::KeyValue> &__ros_vec)
  {
    this->values = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += 0; // OK
    __l += 0; // WARN
    __l += 0; // ERROR
    __l += 1; // level
    __l += 4 + name.length(); // name
    __l += 4 + message.length(); // message
    __l += 4 + hardware_id.length(); // hardware_id
    __l += 4 + calc_values_array_serialization_len(); // values
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    SROS_SERIALIZE_PRIMITIVE(write_ptr, level);
    unsigned __ros_name_len = name.length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_name_len);
    SROS_SERIALIZE_BUFFER(write_ptr, name.c_str(), __ros_name_len);
    unsigned __ros_message_len = message.length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_message_len);
    SROS_SERIALIZE_BUFFER(write_ptr, message.c_str(), __ros_message_len);
    unsigned __ros_hardware_id_len = hardware_id.length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_hardware_id_len);
    SROS_SERIALIZE_BUFFER(write_ptr, hardware_id.c_str(), __ros_hardware_id_len);
    uint32_t __values_size = values.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __values_size);
    for (size_t i = 0; i < __values_size; i++)
      write_ptr = values[i].serialize(write_ptr, seq);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, level);
    unsigned __ros_name_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_name_len);
    name = std::string((const char *)read_ptr, __ros_name_len);
    read_ptr += __ros_name_len;
    unsigned __ros_message_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_message_len);
    message = std::string((const char *)read_ptr, __ros_message_len);
    read_ptr += __ros_message_len;
    unsigned __ros_hardware_id_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_hardware_id_len);
    hardware_id = std::string((const char *)read_ptr, __ros_hardware_id_len);
    read_ptr += __ros_hardware_id_len;
    uint32_t __values_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __values_size);
    set_values_size(__values_size);
    for (size_t i = 0; i < __values_size; i++)
      read_ptr = values[i].deserialize(read_ptr);
    return read_ptr;
  }
};

typedef boost::shared_ptr<DiagnosticStatus> DiagnosticStatusPtr;
typedef boost::shared_ptr<DiagnosticStatus const> DiagnosticStatusConstPtr;


}

#endif
