# autogenerated by genmsg_py from DiagnosticArray.msg. Do not edit.
import roslib.message
import struct

import roslib.msg
import diagnostic_msgs.msg

class DiagnosticArray(roslib.message.Message):
  _md5sum = "3cfbeff055e708a24c3d946a5c8139cd"
  _type = "diagnostic_msgs/DiagnosticArray"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """# This message is used to send diagnostic information about the state of the robot
Header header #for timestamp
DiagnosticStatus[] status # an array of components being reported on
================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: diagnostic_msgs/DiagnosticStatus
# This message holds the status of an individual component of the robot.
# 

# Possible levels of operations
byte OK=0
byte WARN=1
byte ERROR=2

byte level # level of operation enumerated above 
string name # a description of the test/component reporting
string message # a description of the status
string hardware_id # a hardware unique string
KeyValue[] values # an array of values associated with the status


================================================================================
MSG: diagnostic_msgs/KeyValue
string key # what to label this value when viewing
string value # a value to track over time

"""
  __slots__ = ['header','status']
  _slot_types = ['Header','diagnostic_msgs/DiagnosticStatus[]']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   header,status
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(DiagnosticArray, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.status is None:
        self.status = []
    else:
      self.header = roslib.msg._Header.Header()
      self.status = []

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      #serialize self.status
      length = len(self.status)
      buff.write(struct.pack('<I', length))
      for val1 in self.status:
        buff.write(struct.pack('<b', val1.level))
        length = len(val1.name)
        #serialize val1.name
        buff.write(struct.pack('<I%ss'%length, length, val1.name))
        length = len(val1.message)
        #serialize val1.message
        buff.write(struct.pack('<I%ss'%length, length, val1.message))
        length = len(val1.hardware_id)
        #serialize val1.hardware_id
        buff.write(struct.pack('<I%ss'%length, length, val1.hardware_id))
        #serialize val1.values
        length = len(val1.values)
        buff.write(struct.pack('<I', length))
        for val2 in val1.values:
          length = len(val2.key)
          #serialize val2.key
          buff.write(struct.pack('<I%ss'%length, length, val2.key))
          length = len(val2.value)
          #serialize val2.value
          buff.write(struct.pack('<I%ss'%length, length, val2.value))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      #deserialize self.status
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.status = []
      for i in xrange(0, length):
        val1 = diagnostic_msgs.msg.DiagnosticStatus()
        start = end
        end += 1
        (val1.level,) = struct.unpack('<b',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.message
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.message,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.hardware_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.hardware_id,) = struct.unpack(pattern, str[start:end])
        #deserialize val1.values
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.values = []
        for i in xrange(0, length):
          val2 = diagnostic_msgs.msg.KeyValue()
          start = end
          end += 4
          (length,) = struct.unpack('<I',str[start:end])
          #deserialize val2.key
          pattern = '<%ss'%length
          start = end
          end += struct.calcsize(pattern)
          (val2.key,) = struct.unpack(pattern, str[start:end])
          start = end
          end += 4
          (length,) = struct.unpack('<I',str[start:end])
          #deserialize val2.value
          pattern = '<%ss'%length
          start = end
          end += struct.calcsize(pattern)
          (val2.value,) = struct.unpack(pattern, str[start:end])
          val1.values.append(val2)
        self.status.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      #serialize self.status
      length = len(self.status)
      buff.write(struct.pack('<I', length))
      for val1 in self.status:
        buff.write(struct.pack('<b', val1.level))
        length = len(val1.name)
        #serialize val1.name
        buff.write(struct.pack('<I%ss'%length, length, val1.name))
        length = len(val1.message)
        #serialize val1.message
        buff.write(struct.pack('<I%ss'%length, length, val1.message))
        length = len(val1.hardware_id)
        #serialize val1.hardware_id
        buff.write(struct.pack('<I%ss'%length, length, val1.hardware_id))
        #serialize val1.values
        length = len(val1.values)
        buff.write(struct.pack('<I', length))
        for val2 in val1.values:
          length = len(val2.key)
          #serialize val2.key
          buff.write(struct.pack('<I%ss'%length, length, val2.key))
          length = len(val2.value)
          #serialize val2.value
          buff.write(struct.pack('<I%ss'%length, length, val2.value))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      #deserialize self.status
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.status = []
      for i in xrange(0, length):
        val1 = diagnostic_msgs.msg.DiagnosticStatus()
        start = end
        end += 1
        (val1.level,) = struct.unpack('<b',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.message
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.message,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.hardware_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.hardware_id,) = struct.unpack(pattern, str[start:end])
        #deserialize val1.values
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.values = []
        for i in xrange(0, length):
          val2 = diagnostic_msgs.msg.KeyValue()
          start = end
          end += 4
          (length,) = struct.unpack('<I',str[start:end])
          #deserialize val2.key
          pattern = '<%ss'%length
          start = end
          end += struct.calcsize(pattern)
          (val2.key,) = struct.unpack(pattern, str[start:end])
          start = end
          end += 4
          (length,) = struct.unpack('<I',str[start:end])
          #deserialize val2.value
          pattern = '<%ss'%length
          start = end
          end += struct.calcsize(pattern)
          (val2.value,) = struct.unpack(pattern, str[start:end])
          val1.values.append(val2)
        self.status.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

