# autogenerated by genmsg_py from DiagnosticStatus.msg. Do not edit.
import roslib.message
import struct

import diagnostic_msgs.msg

class DiagnosticStatus(roslib.message.Message):
  _md5sum = "67d15a62edb26e9d52b0f0efa3ef9da7"
  _type = "diagnostic_msgs/DiagnosticStatus"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# This message holds the status of an individual component of the robot.
# 

# Possible levels of operations
byte OK=0
byte WARN=1
byte ERROR=2

byte level # level of operation enumerated above 
string name # a description of the test/component reporting
string message # a description of the status
string hardware_id # a hardware unique string
KeyValue[] values # an array of values associated with the status


================================================================================
MSG: diagnostic_msgs/KeyValue
string key # what to label this value when viewing
string value # a value to track over time

"""
  # Pseudo-constants
  OK = 0
  WARN = 1
  ERROR = 2

  __slots__ = ['level','name','message','hardware_id','values']
  _slot_types = ['byte','string','string','string','diagnostic_msgs/KeyValue[]']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   level,name,message,hardware_id,values
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(DiagnosticStatus, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.level is None:
        self.level = 0
      if self.name is None:
        self.name = ''
      if self.message is None:
        self.message = ''
      if self.hardware_id is None:
        self.hardware_id = ''
      if self.values is None:
        self.values = []
    else:
      self.level = 0
      self.name = ''
      self.message = ''
      self.hardware_id = ''
      self.values = []

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      buff.write(struct.pack('<b', self.level))
      length = len(self.name)
      #serialize self.name
      buff.write(struct.pack('<I%ss'%length, length, self.name))
      length = len(self.message)
      #serialize self.message
      buff.write(struct.pack('<I%ss'%length, length, self.message))
      length = len(self.hardware_id)
      #serialize self.hardware_id
      buff.write(struct.pack('<I%ss'%length, length, self.hardware_id))
      #serialize self.values
      length = len(self.values)
      buff.write(struct.pack('<I', length))
      for val1 in self.values:
        length = len(val1.key)
        #serialize val1.key
        buff.write(struct.pack('<I%ss'%length, length, val1.key))
        length = len(val1.value)
        #serialize val1.value
        buff.write(struct.pack('<I%ss'%length, length, val1.value))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      end = 0
      start = end
      end += 1
      (self.level,) = struct.unpack('<b',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.name
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.name,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.message
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.message,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.hardware_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.hardware_id,) = struct.unpack(pattern, str[start:end])
      #deserialize self.values
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.values = []
      for i in xrange(0, length):
        val1 = diagnostic_msgs.msg.KeyValue()
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.key
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.key,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.value
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.value,) = struct.unpack(pattern, str[start:end])
        self.values.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      buff.write(struct.pack('<b', self.level))
      length = len(self.name)
      #serialize self.name
      buff.write(struct.pack('<I%ss'%length, length, self.name))
      length = len(self.message)
      #serialize self.message
      buff.write(struct.pack('<I%ss'%length, length, self.message))
      length = len(self.hardware_id)
      #serialize self.hardware_id
      buff.write(struct.pack('<I%ss'%length, length, self.hardware_id))
      #serialize self.values
      length = len(self.values)
      buff.write(struct.pack('<I', length))
      for val1 in self.values:
        length = len(val1.key)
        #serialize val1.key
        buff.write(struct.pack('<I%ss'%length, length, val1.key))
        length = len(val1.value)
        #serialize val1.value
        buff.write(struct.pack('<I%ss'%length, length, val1.value))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      end = 0
      start = end
      end += 1
      (self.level,) = struct.unpack('<b',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.name
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.name,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.message
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.message,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.hardware_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.hardware_id,) = struct.unpack(pattern, str[start:end])
      #deserialize self.values
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.values = []
      for i in xrange(0, length):
        val1 = diagnostic_msgs.msg.KeyValue()
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.key
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.key,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.value
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.value,) = struct.unpack(pattern, str[start:end])
        self.values.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

