/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/common_msgs/geometry_msgs/msg/PoseWithCovariance.msg.  Do not edit! */
#ifndef GEOMETRY_MSGS_POSEWITHCOVARIANCE_H
#define GEOMETRY_MSGS_POSEWITHCOVARIANCE_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "geometry_msgs/Point.h"
#include "geometry_msgs/Quaternion.h"
#include "geometry_msgs/Pose.h"

namespace geometry_msgs
{

//! \htmlinclude PoseWithCovariance.msg.html

class PoseWithCovariance : public ros::Message
{
public:
  typedef boost::shared_ptr<PoseWithCovariance> Ptr;
  typedef boost::shared_ptr<PoseWithCovariance const> ConstPtr;

  typedef geometry_msgs::Pose _pose_type;
  typedef boost::array<double, 36> _covariance_type;

  geometry_msgs::Pose pose;
  boost::array<double, 36> covariance;

  PoseWithCovariance() : ros::Message()
  {
    covariance.assign(0);
  }
  PoseWithCovariance(const PoseWithCovariance &copy) : ros::Message(),
    pose(copy.pose)
  {
    (void)copy;
    covariance = copy.covariance;
  }
  PoseWithCovariance &operator =(const PoseWithCovariance &copy)
  {
    if (this == &copy)
      return *this;
    pose = copy.pose;
    covariance = copy.covariance;
    return *this;
  }
  virtual ~PoseWithCovariance() 
  {
  }
  inline static std::string __s_getDataType() { return std::string("geometry_msgs/PoseWithCovariance"); }
  inline static std::string __s_getMD5Sum() { return std::string("c23e848cf1b7533a8d7c259073a97e6f"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# This represents a pose in free space with uncertainty.\n"
    "\n"
    "Pose pose\n"
    "\n"
    "# Row-major representation of the 6x6 covariance matrix\n"
    "# The orientation parameters use a fixed-axis representation.\n"
    "# In order, the parameters are:\n"
    "# (x, y, z, rotation about X axis, rotation about Y axis, rotation about Z axis)\n"
    "float64[36] covariance\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Pose\n"
    "# A representation of pose in free space, composed of postion and orientation. \n"
    "Point position\n"
    "Quaternion orientation\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Point\n"
    "# This contains the position of a point in free space\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Quaternion\n"
    "# This represents an orientation in free space in quaternion form.\n"
    "\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "float64 w\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline uint32_t get_covariance_size() const { return 36; }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += pose.serializationLength(); // pose
    __l += 36 * 8; // covariance
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    write_ptr = pose.serialize(write_ptr, seq);
    memcpy(write_ptr, &covariance[0], sizeof(double) * 36);
    write_ptr += sizeof(double) * 36;
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    read_ptr = pose.deserialize(read_ptr);
    memcpy(&covariance[0], read_ptr, sizeof(double) * 36);
    read_ptr += sizeof(double) * 36;
    return read_ptr;
  }
};

typedef boost::shared_ptr<PoseWithCovariance> PoseWithCovariancePtr;
typedef boost::shared_ptr<PoseWithCovariance const> PoseWithCovarianceConstPtr;


}

#endif
