/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/common_msgs/geometry_msgs/msg/TransformStamped.msg.  Do not edit! */
#ifndef GEOMETRY_MSGS_TRANSFORMSTAMPED_H
#define GEOMETRY_MSGS_TRANSFORMSTAMPED_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "roslib/Header.h"
#include "geometry_msgs/Vector3.h"
#include "geometry_msgs/Quaternion.h"
#include "geometry_msgs/Transform.h"

namespace geometry_msgs
{

//! \htmlinclude TransformStamped.msg.html

class TransformStamped : public ros::Message
{
public:
  typedef boost::shared_ptr<TransformStamped> Ptr;
  typedef boost::shared_ptr<TransformStamped const> ConstPtr;

  typedef roslib::Header _header_type;
  typedef std::string _child_frame_id_type;
  typedef geometry_msgs::Transform _transform_type;

  roslib::Header header;
  std::string child_frame_id;
  geometry_msgs::Transform transform;

  TransformStamped() : ros::Message()
  {
  }
  TransformStamped(const TransformStamped &copy) : ros::Message(),
    header(copy.header),
    child_frame_id(copy.child_frame_id),
    transform(copy.transform)
  {
    (void)copy;
  }
  TransformStamped &operator =(const TransformStamped &copy)
  {
    if (this == &copy)
      return *this;
    header = copy.header;
    child_frame_id = copy.child_frame_id;
    transform = copy.transform;
    return *this;
  }
  virtual ~TransformStamped() 
  {
  }
  inline static std::string __s_getDataType() { return std::string("geometry_msgs/TransformStamped"); }
  inline static std::string __s_getMD5Sum() { return std::string("b5764a33bfeb3588febc2682852579b0"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# This expresses a transform from coordinate frame header.frame_id\n"
    "# to the coordinate frame child_frame_id\n"
    "#\n"
    "# This message is mostly used by the \n"
    "# <a href=\"http://www.ros.org/wiki/tf\">tf</a> package. \n"
    "# See it's documentation for more information.\n"
    "\n"
    "Header header\n"
    "string child_frame_id # the frame id of the child frame\n"
    "Transform transform\n"
    "\n"
    "================================================================================\n"
    "MSG: roslib/Header\n"
    "# Standard metadata for higher-level stamped data types.\n"
    "# This is generally used to communicate timestamped data \n"
    "# in a particular coordinate frame.\n"
    "# \n"
    "# sequence ID: consecutively increasing ID \n"
    "uint32 seq\n"
    "#Two-integer timestamp that is expressed as:\n"
    "# * stamp.secs: seconds (stamp_secs) since epoch\n"
    "# * stamp.nsecs: nanoseconds since stamp_secs\n"
    "# time-handling sugar is provided by the client library\n"
    "time stamp\n"
    "#Frame this data is associated with\n"
    "# 0: no frame\n"
    "# 1: global frame\n"
    "string frame_id\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Transform\n"
    "# This represents the transform between two coordinate frames in free space.\n"
    "\n"
    "Vector3 translation\n"
    "Quaternion rotation\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Vector3\n"
    "# This represents a vector in free space. \n"
    "\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Quaternion\n"
    "# This represents an orientation in free space in quaternion form.\n"
    "\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "float64 w\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += header.serializationLength(); // header
    __l += 4 + child_frame_id.length(); // child_frame_id
    __l += transform.serializationLength(); // transform
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
                             uint32_t seq) const
  {
    roslib::Header _ser_header = header;
    bool __reset_seq = (header.seq == 0);
    if (__reset_seq) _ser_header.seq = seq;
    write_ptr = _ser_header.serialize(write_ptr, seq);
    unsigned __ros_child_frame_id_len = child_frame_id.length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_child_frame_id_len);
    SROS_SERIALIZE_BUFFER(write_ptr, child_frame_id.c_str(), __ros_child_frame_id_len);
    write_ptr = transform.serialize(write_ptr, seq);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    read_ptr = header.deserialize(read_ptr);
    unsigned __ros_child_frame_id_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_child_frame_id_len);
    child_frame_id = std::string((const char *)read_ptr, __ros_child_frame_id_len);
    read_ptr += __ros_child_frame_id_len;
    read_ptr = transform.deserialize(read_ptr);
    return read_ptr;
  }
};

typedef boost::shared_ptr<TransformStamped> TransformStampedPtr;
typedef boost::shared_ptr<TransformStamped const> TransformStampedConstPtr;


}

#endif
