/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/common_msgs/geometry_msgs/msg/TwistWithCovariance.msg.  Do not edit! */
#ifndef GEOMETRY_MSGS_TWISTWITHCOVARIANCE_H
#define GEOMETRY_MSGS_TWISTWITHCOVARIANCE_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "geometry_msgs/Vector3.h"
#include "geometry_msgs/Twist.h"

namespace geometry_msgs
{

//! \htmlinclude TwistWithCovariance.msg.html

class TwistWithCovariance : public ros::Message
{
public:
  typedef boost::shared_ptr<TwistWithCovariance> Ptr;
  typedef boost::shared_ptr<TwistWithCovariance const> ConstPtr;

  typedef geometry_msgs::Twist _twist_type;
  typedef boost::array<double, 36> _covariance_type;

  geometry_msgs::Twist twist;
  boost::array<double, 36> covariance;

  TwistWithCovariance() : ros::Message()
  {
    covariance.assign(0);
  }
  TwistWithCovariance(const TwistWithCovariance &copy) : ros::Message(),
    twist(copy.twist)
  {
    (void)copy;
    covariance = copy.covariance;
  }
  TwistWithCovariance &operator =(const TwistWithCovariance &copy)
  {
    if (this == &copy)
      return *this;
    twist = copy.twist;
    covariance = copy.covariance;
    return *this;
  }
  virtual ~TwistWithCovariance() 
  {
  }
  inline static std::string __s_getDataType() { return std::string("geometry_msgs/TwistWithCovariance"); }
  inline static std::string __s_getMD5Sum() { return std::string("1fe8a28e6890a4cc3ae4c3ca5c7d82e6"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# This expresses velocity in free space with uncertianty.\n"
    "\n"
    "Twist twist\n"
    "\n"
    "# Row-major representation of the 6x6 covariance matrix\n"
    "# The orientation parameters use a fixed-axis representation.\n"
    "# In order, the parameters are:\n"
    "# (x, y, z, rotation about X axis, rotation about Y axis, rotation about Z axis)\n"
    "float64[36] covariance\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Twist\n"
    "# This expresses velocity in free space broken into it's linear and angular parts. \n"
    "Vector3  linear\n"
    "Vector3  angular\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Vector3\n"
    "# This represents a vector in free space. \n"
    "\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline uint32_t get_covariance_size() const { return 36; }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += twist.serializationLength(); // twist
    __l += 36 * 8; // covariance
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    write_ptr = twist.serialize(write_ptr, seq);
    memcpy(write_ptr, &covariance[0], sizeof(double) * 36);
    write_ptr += sizeof(double) * 36;
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    read_ptr = twist.deserialize(read_ptr);
    memcpy(&covariance[0], read_ptr, sizeof(double) * 36);
    read_ptr += sizeof(double) * 36;
    return read_ptr;
  }
};

typedef boost::shared_ptr<TwistWithCovariance> TwistWithCovariancePtr;
typedef boost::shared_ptr<TwistWithCovariance const> TwistWithCovarianceConstPtr;


}

#endif
