# autogenerated by genmsg_py from TransformStamped.msg. Do not edit.
import roslib.message
import struct

import geometry_msgs.msg
import roslib.msg

class TransformStamped(roslib.message.Message):
  _md5sum = "b5764a33bfeb3588febc2682852579b0"
  _type = "geometry_msgs/TransformStamped"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """# This expresses a transform from coordinate frame header.frame_id
# to the coordinate frame child_frame_id
#
# This message is mostly used by the 
# <a href="http://www.ros.org/wiki/tf">tf</a> package. 
# See it's documentation for more information.

Header header
string child_frame_id # the frame id of the child frame
Transform transform

================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Transform
# This represents the transform between two coordinate frames in free space.

Vector3 translation
Quaternion rotation

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

"""
  __slots__ = ['header','child_frame_id','transform']
  _slot_types = ['Header','string','geometry_msgs/Transform']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   header,child_frame_id,transform
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(TransformStamped, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.child_frame_id is None:
        self.child_frame_id = ''
      if self.transform is None:
        self.transform = geometry_msgs.msg.Transform()
    else:
      self.header = roslib.msg._Header.Header()
      self.child_frame_id = ''
      self.transform = geometry_msgs.msg.Transform()

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      length = len(self.child_frame_id)
      #serialize self.child_frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.child_frame_id))
      buff.write(struct.pack('<7d', self.transform.translation.x, self.transform.translation.y, self.transform.translation.z, self.transform.rotation.x, self.transform.rotation.y, self.transform.rotation.z, self.transform.rotation.w))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.transform is None:
        self.transform = geometry_msgs.msg.Transform()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.child_frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.child_frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 56
      (self.transform.translation.x, self.transform.translation.y, self.transform.translation.z, self.transform.rotation.x, self.transform.rotation.y, self.transform.rotation.z, self.transform.rotation.w,) = struct.unpack('<7d',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      length = len(self.child_frame_id)
      #serialize self.child_frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.child_frame_id))
      buff.write(struct.pack('<7d', self.transform.translation.x, self.transform.translation.y, self.transform.translation.z, self.transform.rotation.x, self.transform.rotation.y, self.transform.rotation.z, self.transform.rotation.w))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.transform is None:
        self.transform = geometry_msgs.msg.Transform()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.child_frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.child_frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 56
      (self.transform.translation.x, self.transform.translation.y, self.transform.translation.z, self.transform.rotation.x, self.transform.rotation.y, self.transform.rotation.z, self.transform.rotation.w,) = struct.unpack('<7d',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

