# autogenerated by genmsg_py from TwistWithCovariance.msg. Do not edit.
import roslib.message
import struct

import geometry_msgs.msg

class TwistWithCovariance(roslib.message.Message):
  _md5sum = "1fe8a28e6890a4cc3ae4c3ca5c7d82e6"
  _type = "geometry_msgs/TwistWithCovariance"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# This expresses velocity in free space with uncertianty.

Twist twist

# Row-major representation of the 6x6 covariance matrix
# The orientation parameters use a fixed-axis representation.
# In order, the parameters are:
# (x, y, z, rotation about X axis, rotation about Y axis, rotation about Z axis)
float64[36] covariance

================================================================================
MSG: geometry_msgs/Twist
# This expresses velocity in free space broken into it's linear and angular parts. 
Vector3  linear
Vector3  angular

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
"""
  __slots__ = ['twist','covariance']
  _slot_types = ['geometry_msgs/Twist','float64[36]']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   twist,covariance
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(TwistWithCovariance, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.twist is None:
        self.twist = geometry_msgs.msg.Twist()
      if self.covariance is None:
        self.covariance = [0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.]
    else:
      self.twist = geometry_msgs.msg.Twist()
      self.covariance = [0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.]

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      buff.write(struct.pack('<6d', self.twist.linear.x, self.twist.linear.y, self.twist.linear.z, self.twist.angular.x, self.twist.angular.y, self.twist.angular.z))
      #serialize self.covariance
      buff.write(struct.pack('<36d', *self.covariance))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.twist is None:
        self.twist = geometry_msgs.msg.Twist()
      end = 0
      start = end
      end += 48
      (self.twist.linear.x, self.twist.linear.y, self.twist.linear.z, self.twist.angular.x, self.twist.angular.y, self.twist.angular.z,) = struct.unpack('<6d',str[start:end])
      #deserialize self.covariance
      start = end
      end += 288
      self.covariance = struct.unpack('<36d',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      buff.write(struct.pack('<6d', self.twist.linear.x, self.twist.linear.y, self.twist.linear.z, self.twist.angular.x, self.twist.angular.y, self.twist.angular.z))
      #serialize self.covariance
      buff.write(self.covariance.tostring())
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.twist is None:
        self.twist = geometry_msgs.msg.Twist()
      end = 0
      start = end
      end += 48
      (self.twist.linear.x, self.twist.linear.y, self.twist.linear.z, self.twist.angular.x, self.twist.angular.y, self.twist.angular.z,) = struct.unpack('<6d',str[start:end])
      #deserialize self.covariance
      start = end
      end += 288
      self.covariance = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=36)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

