/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/common_msgs/nav_msgs/msg/MapMetaData.msg.  Do not edit! */
#ifndef NAV_MSGS_MAPMETADATA_H
#define NAV_MSGS_MAPMETADATA_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "geometry_msgs/Point.h"
#include "geometry_msgs/Quaternion.h"
#include "geometry_msgs/Pose.h"

namespace nav_msgs
{

//! \htmlinclude MapMetaData.msg.html

class MapMetaData : public ros::Message
{
public:
  typedef boost::shared_ptr<MapMetaData> Ptr;
  typedef boost::shared_ptr<MapMetaData const> ConstPtr;

  typedef ros::Time _map_load_time_type;
  typedef float _resolution_type;
  typedef uint32_t _width_type;
  typedef uint32_t _height_type;
  typedef geometry_msgs::Pose _origin_type;

  ros::Time map_load_time;
  float resolution;
  uint32_t width;
  uint32_t height;
  geometry_msgs::Pose origin;

  MapMetaData() : ros::Message(),
    resolution(0),
    width(0),
    height(0)
  {
  }
  MapMetaData(const MapMetaData &copy) : ros::Message(),
    map_load_time(copy.map_load_time),
    resolution(copy.resolution),
    width(copy.width),
    height(copy.height),
    origin(copy.origin)
  {
    (void)copy;
  }
  MapMetaData &operator =(const MapMetaData &copy)
  {
    if (this == &copy)
      return *this;
    map_load_time = copy.map_load_time;
    resolution = copy.resolution;
    width = copy.width;
    height = copy.height;
    origin = copy.origin;
    return *this;
  }
  virtual ~MapMetaData() 
  {
  }
  inline static std::string __s_getDataType() { return std::string("nav_msgs/MapMetaData"); }
  inline static std::string __s_getMD5Sum() { return std::string("10cfc8a2818024d3248802c00c95f11b"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# This hold basic information about the characterists of the OccupancyGrid\n"
    "\n"
    "# The time at which the map was loaded\n"
    "time map_load_time\n"
    "# The map resolution [m/cell]\n"
    "float32 resolution\n"
    "# Map width [cells]\n"
    "uint32 width\n"
    "# Map height [cells]\n"
    "uint32 height\n"
    "# The origin of the map [m, m, rad].  This is the real-world pose of the\n"
    "# cell (0,0) in the map.\n"
    "geometry_msgs/Pose origin\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Pose\n"
    "# A representation of pose in free space, composed of postion and orientation. \n"
    "Point position\n"
    "Quaternion orientation\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Point\n"
    "# This contains the position of a point in free space\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Quaternion\n"
    "# This represents an orientation in free space in quaternion form.\n"
    "\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "float64 w\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += 8; // map_load_time
    __l += 4; // resolution
    __l += 4; // width
    __l += 4; // height
    __l += origin.serializationLength(); // origin
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    SROS_SERIALIZE_PRIMITIVE(write_ptr, map_load_time.sec);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, map_load_time.nsec);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, resolution);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, width);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, height);
    write_ptr = origin.serialize(write_ptr, seq);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, map_load_time.sec);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, map_load_time.nsec);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, resolution);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, width);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, height);
    read_ptr = origin.deserialize(read_ptr);
    return read_ptr;
  }
};

typedef boost::shared_ptr<MapMetaData> MapMetaDataPtr;
typedef boost::shared_ptr<MapMetaData const> MapMetaDataConstPtr;


}

#endif
