/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/common_msgs/nav_msgs/msg/OccupancyGrid.msg.  Do not edit! */
#ifndef NAV_MSGS_OCCUPANCYGRID_H
#define NAV_MSGS_OCCUPANCYGRID_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "roslib/Header.h"
#include "geometry_msgs/Point.h"
#include "geometry_msgs/Quaternion.h"
#include "geometry_msgs/Pose.h"
#include "nav_msgs/MapMetaData.h"

namespace nav_msgs
{

//! \htmlinclude OccupancyGrid.msg.html

class OccupancyGrid : public ros::Message
{
public:
  typedef boost::shared_ptr<OccupancyGrid> Ptr;
  typedef boost::shared_ptr<OccupancyGrid const> ConstPtr;

  typedef roslib::Header _header_type;
  typedef nav_msgs::MapMetaData _info_type;
  typedef std::vector<int8_t> _data_type;

  roslib::Header header;
  nav_msgs::MapMetaData info;
  std::vector<int8_t> data;

  OccupancyGrid() : ros::Message()
  {
  }
  OccupancyGrid(const OccupancyGrid &copy) : ros::Message(),
    header(copy.header),
    info(copy.info)
  {
    (void)copy;
    data = copy.data;
  }
  OccupancyGrid &operator =(const OccupancyGrid &copy)
  {
    if (this == &copy)
      return *this;
    data.clear();
    header = copy.header;
    info = copy.info;
    data = copy.data;
    return *this;
  }
  virtual ~OccupancyGrid() 
  {
    data.clear();
  }
  inline static std::string __s_getDataType() { return std::string("nav_msgs/OccupancyGrid"); }
  inline static std::string __s_getMD5Sum() { return std::string("3381f2d731d4076ec5c71b0759edbe4e"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# This represents a 2-D grid map, in which each cell represents the probability of\n"
    "# occupancy.\n"
    "\n"
    "Header header \n"
    "\n"
    "#MetaData for the map\n"
    "MapMetaData info\n"
    "\n"
    "# The map data, in row-major order, starting with (0,0).  Occupancy\n"
    "# probabilities are in the range [0,100].  Unknown is -1.\n"
    "int8[] data\n"
    "\n"
    "================================================================================\n"
    "MSG: roslib/Header\n"
    "# Standard metadata for higher-level stamped data types.\n"
    "# This is generally used to communicate timestamped data \n"
    "# in a particular coordinate frame.\n"
    "# \n"
    "# sequence ID: consecutively increasing ID \n"
    "uint32 seq\n"
    "#Two-integer timestamp that is expressed as:\n"
    "# * stamp.secs: seconds (stamp_secs) since epoch\n"
    "# * stamp.nsecs: nanoseconds since stamp_secs\n"
    "# time-handling sugar is provided by the client library\n"
    "time stamp\n"
    "#Frame this data is associated with\n"
    "# 0: no frame\n"
    "# 1: global frame\n"
    "string frame_id\n"
    "\n"
    "================================================================================\n"
    "MSG: nav_msgs/MapMetaData\n"
    "# This hold basic information about the characterists of the OccupancyGrid\n"
    "\n"
    "# The time at which the map was loaded\n"
    "time map_load_time\n"
    "# The map resolution [m/cell]\n"
    "float32 resolution\n"
    "# Map width [cells]\n"
    "uint32 width\n"
    "# Map height [cells]\n"
    "uint32 height\n"
    "# The origin of the map [m, m, rad].  This is the real-world pose of the\n"
    "# cell (0,0) in the map.\n"
    "geometry_msgs/Pose origin\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Pose\n"
    "# A representation of pose in free space, composed of postion and orientation. \n"
    "Point position\n"
    "Quaternion orientation\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Point\n"
    "# This contains the position of a point in free space\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Quaternion\n"
    "# This represents an orientation in free space in quaternion form.\n"
    "\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "float64 w\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  void set_data_size(uint32_t __ros_new_size)
  {
    this->data.resize(__ros_new_size);
  }
  inline uint32_t get_data_size() const { return data.size(); }
  inline void get_data_vec (std::vector<int8_t> &__ros_vec) const
  {
    __ros_vec = this->data;
  }
  inline void set_data_vec(const std::vector<int8_t> &__ros_vec)
  {
    this->data = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += header.serializationLength(); // header
    __l += info.serializationLength(); // info
    __l += 4 + (data.size() ? data.size() * 1 : 0); // data
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
                             uint32_t seq) const
  {
    roslib::Header _ser_header = header;
    bool __reset_seq = (header.seq == 0);
    if (__reset_seq) _ser_header.seq = seq;
    write_ptr = _ser_header.serialize(write_ptr, seq);
    write_ptr = info.serialize(write_ptr, seq);
    uint32_t __data_size = data.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __data_size);
    memcpy(write_ptr, &data[0], sizeof(int8_t) * __data_size);
    write_ptr += sizeof(int8_t) * __data_size;
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    read_ptr = header.deserialize(read_ptr);
    read_ptr = info.deserialize(read_ptr);
    uint32_t __data_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __data_size);
    set_data_size(__data_size);
    memcpy(&data[0], read_ptr, sizeof(int8_t) * __data_size);
    read_ptr += sizeof(int8_t) * __data_size;
    return read_ptr;
  }
};

typedef boost::shared_ptr<OccupancyGrid> OccupancyGridPtr;
typedef boost::shared_ptr<OccupancyGrid const> OccupancyGridConstPtr;


}

#endif
