/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/common_msgs/nav_msgs/msg/Odometry.msg.  Do not edit! */
#ifndef NAV_MSGS_ODOMETRY_H
#define NAV_MSGS_ODOMETRY_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "roslib/Header.h"
#include "geometry_msgs/Point.h"
#include "geometry_msgs/Quaternion.h"
#include "geometry_msgs/Pose.h"
#include "geometry_msgs/PoseWithCovariance.h"
#include "geometry_msgs/Vector3.h"
#include "geometry_msgs/Twist.h"
#include "geometry_msgs/TwistWithCovariance.h"

namespace nav_msgs
{

//! \htmlinclude Odometry.msg.html

class Odometry : public ros::Message
{
public:
  typedef boost::shared_ptr<Odometry> Ptr;
  typedef boost::shared_ptr<Odometry const> ConstPtr;

  typedef roslib::Header _header_type;
  typedef std::string _child_frame_id_type;
  typedef geometry_msgs::PoseWithCovariance _pose_type;
  typedef geometry_msgs::TwistWithCovariance _twist_type;

  roslib::Header header;
  std::string child_frame_id;
  geometry_msgs::PoseWithCovariance pose;
  geometry_msgs::TwistWithCovariance twist;

  Odometry() : ros::Message()
  {
  }
  Odometry(const Odometry &copy) : ros::Message(),
    header(copy.header),
    child_frame_id(copy.child_frame_id),
    pose(copy.pose),
    twist(copy.twist)
  {
    (void)copy;
  }
  Odometry &operator =(const Odometry &copy)
  {
    if (this == &copy)
      return *this;
    header = copy.header;
    child_frame_id = copy.child_frame_id;
    pose = copy.pose;
    twist = copy.twist;
    return *this;
  }
  virtual ~Odometry() 
  {
  }
  inline static std::string __s_getDataType() { return std::string("nav_msgs/Odometry"); }
  inline static std::string __s_getMD5Sum() { return std::string("cd5e73d190d741a2f92e81eda573aca7"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# This represents an estimate of a position and velocity in free space.  \n"
    "# The pose in this message should be specified in the coordinate frame given by header.frame_id.\n"
    "# The twist in this message should be specified in the coordinate frame given by the child_frame_id\n"
    "Header header\n"
    "string child_frame_id\n"
    "geometry_msgs/PoseWithCovariance pose\n"
    "geometry_msgs/TwistWithCovariance twist\n"
    "\n"
    "================================================================================\n"
    "MSG: roslib/Header\n"
    "# Standard metadata for higher-level stamped data types.\n"
    "# This is generally used to communicate timestamped data \n"
    "# in a particular coordinate frame.\n"
    "# \n"
    "# sequence ID: consecutively increasing ID \n"
    "uint32 seq\n"
    "#Two-integer timestamp that is expressed as:\n"
    "# * stamp.secs: seconds (stamp_secs) since epoch\n"
    "# * stamp.nsecs: nanoseconds since stamp_secs\n"
    "# time-handling sugar is provided by the client library\n"
    "time stamp\n"
    "#Frame this data is associated with\n"
    "# 0: no frame\n"
    "# 1: global frame\n"
    "string frame_id\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/PoseWithCovariance\n"
    "# This represents a pose in free space with uncertainty.\n"
    "\n"
    "Pose pose\n"
    "\n"
    "# Row-major representation of the 6x6 covariance matrix\n"
    "# The orientation parameters use a fixed-axis representation.\n"
    "# In order, the parameters are:\n"
    "# (x, y, z, rotation about X axis, rotation about Y axis, rotation about Z axis)\n"
    "float64[36] covariance\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Pose\n"
    "# A representation of pose in free space, composed of postion and orientation. \n"
    "Point position\n"
    "Quaternion orientation\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Point\n"
    "# This contains the position of a point in free space\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Quaternion\n"
    "# This represents an orientation in free space in quaternion form.\n"
    "\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "float64 w\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/TwistWithCovariance\n"
    "# This expresses velocity in free space with uncertianty.\n"
    "\n"
    "Twist twist\n"
    "\n"
    "# Row-major representation of the 6x6 covariance matrix\n"
    "# The orientation parameters use a fixed-axis representation.\n"
    "# In order, the parameters are:\n"
    "# (x, y, z, rotation about X axis, rotation about Y axis, rotation about Z axis)\n"
    "float64[36] covariance\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Twist\n"
    "# This expresses velocity in free space broken into it's linear and angular parts. \n"
    "Vector3  linear\n"
    "Vector3  angular\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Vector3\n"
    "# This represents a vector in free space. \n"
    "\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += header.serializationLength(); // header
    __l += 4 + child_frame_id.length(); // child_frame_id
    __l += pose.serializationLength(); // pose
    __l += twist.serializationLength(); // twist
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
                             uint32_t seq) const
  {
    roslib::Header _ser_header = header;
    bool __reset_seq = (header.seq == 0);
    if (__reset_seq) _ser_header.seq = seq;
    write_ptr = _ser_header.serialize(write_ptr, seq);
    unsigned __ros_child_frame_id_len = child_frame_id.length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_child_frame_id_len);
    SROS_SERIALIZE_BUFFER(write_ptr, child_frame_id.c_str(), __ros_child_frame_id_len);
    write_ptr = pose.serialize(write_ptr, seq);
    write_ptr = twist.serialize(write_ptr, seq);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    read_ptr = header.deserialize(read_ptr);
    unsigned __ros_child_frame_id_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_child_frame_id_len);
    child_frame_id = std::string((const char *)read_ptr, __ros_child_frame_id_len);
    read_ptr += __ros_child_frame_id_len;
    read_ptr = pose.deserialize(read_ptr);
    read_ptr = twist.deserialize(read_ptr);
    return read_ptr;
  }
};

typedef boost::shared_ptr<Odometry> OdometryPtr;
typedef boost::shared_ptr<Odometry const> OdometryConstPtr;


}

#endif
