/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/common_msgs/nav_msgs/msg/Path.msg.  Do not edit! */
#ifndef NAV_MSGS_PATH_H
#define NAV_MSGS_PATH_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "roslib/Header.h"
#include "geometry_msgs/Point.h"
#include "geometry_msgs/Quaternion.h"
#include "geometry_msgs/Pose.h"
#include "geometry_msgs/PoseStamped.h"

namespace nav_msgs
{

//! \htmlinclude Path.msg.html

class Path : public ros::Message
{
public:
  typedef boost::shared_ptr<Path> Ptr;
  typedef boost::shared_ptr<Path const> ConstPtr;

  typedef roslib::Header _header_type;
  typedef std::vector<geometry_msgs::PoseStamped> _poses_type;

  roslib::Header header;
  std::vector<geometry_msgs::PoseStamped> poses;

  Path() : ros::Message()
  {
  }
  Path(const Path &copy) : ros::Message(),
    header(copy.header)
  {
    (void)copy;
    poses = copy.poses;
  }
  Path &operator =(const Path &copy)
  {
    if (this == &copy)
      return *this;
    poses.clear();
    header = copy.header;
    poses = copy.poses;
    return *this;
  }
  virtual ~Path() 
  {
    poses.clear();
  }
  inline static std::string __s_getDataType() { return std::string("nav_msgs/Path"); }
  inline static std::string __s_getMD5Sum() { return std::string("6227e2b7e9cce15051f669a5e197bbf7"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "#An array of poses that represents a Path for a robot to follow\n"
    "Header header\n"
    "geometry_msgs/PoseStamped[] poses\n"
    "\n"
    "================================================================================\n"
    "MSG: roslib/Header\n"
    "# Standard metadata for higher-level stamped data types.\n"
    "# This is generally used to communicate timestamped data \n"
    "# in a particular coordinate frame.\n"
    "# \n"
    "# sequence ID: consecutively increasing ID \n"
    "uint32 seq\n"
    "#Two-integer timestamp that is expressed as:\n"
    "# * stamp.secs: seconds (stamp_secs) since epoch\n"
    "# * stamp.nsecs: nanoseconds since stamp_secs\n"
    "# time-handling sugar is provided by the client library\n"
    "time stamp\n"
    "#Frame this data is associated with\n"
    "# 0: no frame\n"
    "# 1: global frame\n"
    "string frame_id\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/PoseStamped\n"
    "# A Pose with reference coordinate frame and timestamp\n"
    "Header header\n"
    "Pose pose\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Pose\n"
    "# A representation of pose in free space, composed of postion and orientation. \n"
    "Point position\n"
    "Quaternion orientation\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Point\n"
    "# This contains the position of a point in free space\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Quaternion\n"
    "# This represents an orientation in free space in quaternion form.\n"
    "\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "float64 w\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  void set_poses_size(uint32_t __ros_new_size)
  {
    this->poses.resize(__ros_new_size);
  }
  inline uint32_t get_poses_size() const { return poses.size(); }
  uint32_t calc_poses_array_serialization_len() const
  {
    uint32_t l = 0;
    uint32_t poses_size = poses.size();
    for (size_t i = 0; i < poses_size; i++)
      l += poses[i].serializationLength();
    return l;
  }
  inline void get_poses_vec (std::vector<geometry_msgs::PoseStamped> &__ros_vec) const
  {
    __ros_vec = this->poses;
  }
  inline void set_poses_vec(const std::vector<geometry_msgs::PoseStamped> &__ros_vec)
  {
    this->poses = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += header.serializationLength(); // header
    __l += 4 + calc_poses_array_serialization_len(); // poses
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
                             uint32_t seq) const
  {
    roslib::Header _ser_header = header;
    bool __reset_seq = (header.seq == 0);
    if (__reset_seq) _ser_header.seq = seq;
    write_ptr = _ser_header.serialize(write_ptr, seq);
    uint32_t __poses_size = poses.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __poses_size);
    for (size_t i = 0; i < __poses_size; i++)
      write_ptr = poses[i].serialize(write_ptr, seq);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    read_ptr = header.deserialize(read_ptr);
    uint32_t __poses_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __poses_size);
    set_poses_size(__poses_size);
    for (size_t i = 0; i < __poses_size; i++)
      read_ptr = poses[i].deserialize(read_ptr);
    return read_ptr;
  }
};

typedef boost::shared_ptr<Path> PathPtr;
typedef boost::shared_ptr<Path const> PathConstPtr;


}

#endif
