# autogenerated by genmsg_py from MapMetaData.msg. Do not edit.
import roslib.message
import struct

import geometry_msgs.msg
import roslib.rostime

class MapMetaData(roslib.message.Message):
  _md5sum = "10cfc8a2818024d3248802c00c95f11b"
  _type = "nav_msgs/MapMetaData"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# This hold basic information about the characterists of the OccupancyGrid

# The time at which the map was loaded
time map_load_time
# The map resolution [m/cell]
float32 resolution
# Map width [cells]
uint32 width
# Map height [cells]
uint32 height
# The origin of the map [m, m, rad].  This is the real-world pose of the
# cell (0,0) in the map.
geometry_msgs/Pose origin
================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

"""
  __slots__ = ['map_load_time','resolution','width','height','origin']
  _slot_types = ['time','float32','uint32','uint32','geometry_msgs/Pose']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   map_load_time,resolution,width,height,origin
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(MapMetaData, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.map_load_time is None:
        self.map_load_time = roslib.rostime.Time()
      if self.resolution is None:
        self.resolution = 0.
      if self.width is None:
        self.width = 0
      if self.height is None:
        self.height = 0
      if self.origin is None:
        self.origin = geometry_msgs.msg.Pose()
    else:
      self.map_load_time = roslib.rostime.Time()
      self.resolution = 0.
      self.width = 0
      self.height = 0
      self.origin = geometry_msgs.msg.Pose()

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      buff.write(struct.pack('<2If2I7d', self.map_load_time.secs, self.map_load_time.nsecs, self.resolution, self.width, self.height, self.origin.position.x, self.origin.position.y, self.origin.position.z, self.origin.orientation.x, self.origin.orientation.y, self.origin.orientation.z, self.origin.orientation.w))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.map_load_time is None:
        self.map_load_time = roslib.rostime.Time()
      if self.origin is None:
        self.origin = geometry_msgs.msg.Pose()
      end = 0
      start = end
      end += 76
      (self.map_load_time.secs, self.map_load_time.nsecs, self.resolution, self.width, self.height, self.origin.position.x, self.origin.position.y, self.origin.position.z, self.origin.orientation.x, self.origin.orientation.y, self.origin.orientation.z, self.origin.orientation.w,) = struct.unpack('<2If2I7d',str[start:end])
      self.map_load_time.canon()
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      buff.write(struct.pack('<2If2I7d', self.map_load_time.secs, self.map_load_time.nsecs, self.resolution, self.width, self.height, self.origin.position.x, self.origin.position.y, self.origin.position.z, self.origin.orientation.x, self.origin.orientation.y, self.origin.orientation.z, self.origin.orientation.w))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.map_load_time is None:
        self.map_load_time = roslib.rostime.Time()
      if self.origin is None:
        self.origin = geometry_msgs.msg.Pose()
      end = 0
      start = end
      end += 76
      (self.map_load_time.secs, self.map_load_time.nsecs, self.resolution, self.width, self.height, self.origin.position.x, self.origin.position.y, self.origin.position.z, self.origin.orientation.x, self.origin.orientation.y, self.origin.orientation.z, self.origin.orientation.w,) = struct.unpack('<2If2I7d',str[start:end])
      self.map_load_time.canon()
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

