# autogenerated by genmsg_py from OccupancyGrid.msg. Do not edit.
import roslib.message
import struct

import geometry_msgs.msg
import roslib.rostime
import nav_msgs.msg
import roslib.msg

class OccupancyGrid(roslib.message.Message):
  _md5sum = "3381f2d731d4076ec5c71b0759edbe4e"
  _type = "nav_msgs/OccupancyGrid"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """# This represents a 2-D grid map, in which each cell represents the probability of
# occupancy.

Header header 

#MetaData for the map
MapMetaData info

# The map data, in row-major order, starting with (0,0).  Occupancy
# probabilities are in the range [0,100].  Unknown is -1.
int8[] data

================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: nav_msgs/MapMetaData
# This hold basic information about the characterists of the OccupancyGrid

# The time at which the map was loaded
time map_load_time
# The map resolution [m/cell]
float32 resolution
# Map width [cells]
uint32 width
# Map height [cells]
uint32 height
# The origin of the map [m, m, rad].  This is the real-world pose of the
# cell (0,0) in the map.
geometry_msgs/Pose origin
================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

"""
  __slots__ = ['header','info','data']
  _slot_types = ['Header','nav_msgs/MapMetaData','int8[]']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   header,info,data
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(OccupancyGrid, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.info is None:
        self.info = nav_msgs.msg.MapMetaData()
      if self.data is None:
        self.data = []
    else:
      self.header = roslib.msg._Header.Header()
      self.info = nav_msgs.msg.MapMetaData()
      self.data = []

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      buff.write(struct.pack('<2If2I7d', self.info.map_load_time.secs, self.info.map_load_time.nsecs, self.info.resolution, self.info.width, self.info.height, self.info.origin.position.x, self.info.origin.position.y, self.info.origin.position.z, self.info.origin.orientation.x, self.info.origin.orientation.y, self.info.origin.orientation.z, self.info.origin.orientation.w))
      #serialize self.data
      length = len(self.data)
      buff.write(struct.pack('<I', length))
      pattern = '<%sb'%length
      buff.write(struct.pack(pattern, *self.data))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.info is None:
        self.info = nav_msgs.msg.MapMetaData()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 76
      (self.info.map_load_time.secs, self.info.map_load_time.nsecs, self.info.resolution, self.info.width, self.info.height, self.info.origin.position.x, self.info.origin.position.y, self.info.origin.position.z, self.info.origin.orientation.x, self.info.origin.orientation.y, self.info.origin.orientation.z, self.info.origin.orientation.w,) = struct.unpack('<2If2I7d',str[start:end])
      #deserialize self.data
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sb'%length
      start = end
      end += struct.calcsize(pattern)
      self.data = struct.unpack(pattern, str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      buff.write(struct.pack('<2If2I7d', self.info.map_load_time.secs, self.info.map_load_time.nsecs, self.info.resolution, self.info.width, self.info.height, self.info.origin.position.x, self.info.origin.position.y, self.info.origin.position.z, self.info.origin.orientation.x, self.info.origin.orientation.y, self.info.origin.orientation.z, self.info.origin.orientation.w))
      #serialize self.data
      length = len(self.data)
      buff.write(struct.pack('<I', length))
      pattern = '<%sb'%length
      buff.write(self.data.tostring())
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.info is None:
        self.info = nav_msgs.msg.MapMetaData()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 76
      (self.info.map_load_time.secs, self.info.map_load_time.nsecs, self.info.resolution, self.info.width, self.info.height, self.info.origin.position.x, self.info.origin.position.y, self.info.origin.position.z, self.info.origin.orientation.x, self.info.origin.orientation.y, self.info.origin.orientation.z, self.info.origin.orientation.w,) = struct.unpack('<2If2I7d',str[start:end])
      #deserialize self.data
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sb'%length
      start = end
      end += struct.calcsize(pattern)
      self.data = numpy.frombuffer(str[start:end], dtype=numpy.int8, count=length)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

