# autogenerated by genmsg_py from Path.msg. Do not edit.
import roslib.message
import struct

import geometry_msgs.msg
import roslib.msg

class Path(roslib.message.Message):
  _md5sum = "6227e2b7e9cce15051f669a5e197bbf7"
  _type = "nav_msgs/Path"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """#An array of poses that represents a Path for a robot to follow
Header header
geometry_msgs/PoseStamped[] poses

================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

"""
  __slots__ = ['header','poses']
  _slot_types = ['Header','geometry_msgs/PoseStamped[]']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   header,poses
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(Path, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.poses is None:
        self.poses = []
    else:
      self.header = roslib.msg._Header.Header()
      self.poses = []

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      #serialize self.poses
      length = len(self.poses)
      buff.write(struct.pack('<I', length))
      for val1 in self.poses:
        buff.write(struct.pack('<I', val1.header.seq))
        buff.write(struct.pack('<2I', val1.header.stamp.secs, val1.header.stamp.nsecs))
        length = len(val1.header.frame_id)
        #serialize val1.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.header.frame_id))
        buff.write(struct.pack('<3d', val1.pose.position.x, val1.pose.position.y, val1.pose.position.z))
        buff.write(struct.pack('<4d', val1.pose.orientation.x, val1.pose.orientation.y, val1.pose.orientation.z, val1.pose.orientation.w))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      #deserialize self.poses
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.poses = []
      for i in xrange(0, length):
        val1 = geometry_msgs.msg.PoseStamped()
        start = end
        end += 4
        (val1.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.header.stamp.secs, val1.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.header.frame_id,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 24
        (val1.pose.position.x, val1.pose.position.y, val1.pose.position.z,) = struct.unpack('<3d',str[start:end])
        start = end
        end += 32
        (val1.pose.orientation.x, val1.pose.orientation.y, val1.pose.orientation.z, val1.pose.orientation.w,) = struct.unpack('<4d',str[start:end])
        self.poses.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      #serialize self.poses
      length = len(self.poses)
      buff.write(struct.pack('<I', length))
      for val1 in self.poses:
        buff.write(struct.pack('<I', val1.header.seq))
        buff.write(struct.pack('<2I', val1.header.stamp.secs, val1.header.stamp.nsecs))
        length = len(val1.header.frame_id)
        #serialize val1.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.header.frame_id))
        buff.write(struct.pack('<3d', val1.pose.position.x, val1.pose.position.y, val1.pose.position.z))
        buff.write(struct.pack('<4d', val1.pose.orientation.x, val1.pose.orientation.y, val1.pose.orientation.z, val1.pose.orientation.w))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      #deserialize self.poses
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.poses = []
      for i in xrange(0, length):
        val1 = geometry_msgs.msg.PoseStamped()
        start = end
        end += 4
        (val1.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.header.stamp.secs, val1.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.header.frame_id,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 24
        (val1.pose.position.x, val1.pose.position.y, val1.pose.position.z,) = struct.unpack('<3d',str[start:end])
        start = end
        end += 32
        (val1.pose.orientation.x, val1.pose.orientation.y, val1.pose.orientation.z, val1.pose.orientation.w,) = struct.unpack('<4d',str[start:end])
        self.poses.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

