/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/common_msgs/sensor_msgs/msg/CameraInfo.msg.  Do not edit! */
#ifndef SENSOR_MSGS_CAMERAINFO_H
#define SENSOR_MSGS_CAMERAINFO_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "roslib/Header.h"
#include "sensor_msgs/RegionOfInterest.h"

namespace sensor_msgs
{

//! \htmlinclude CameraInfo.msg.html

class CameraInfo : public ros::Message
{
public:
  typedef boost::shared_ptr<CameraInfo> Ptr;
  typedef boost::shared_ptr<CameraInfo const> ConstPtr;

  typedef roslib::Header _header_type;
  typedef uint32_t _height_type;
  typedef uint32_t _width_type;
  typedef sensor_msgs::RegionOfInterest _roi_type;
  typedef boost::array<double, 5> _D_type;
  typedef boost::array<double, 9> _K_type;
  typedef boost::array<double, 9> _R_type;
  typedef boost::array<double, 12> _P_type;

  roslib::Header header;
  uint32_t height;
  uint32_t width;
  sensor_msgs::RegionOfInterest roi;
  boost::array<double, 5> D;
  boost::array<double, 9> K;
  boost::array<double, 9> R;
  boost::array<double, 12> P;

  CameraInfo() : ros::Message(),
    height(0),
    width(0)
  {
    D.assign(0);
    K.assign(0);
    R.assign(0);
    P.assign(0);
  }
  CameraInfo(const CameraInfo &copy) : ros::Message(),
    header(copy.header),
    height(copy.height),
    width(copy.width),
    roi(copy.roi)
  {
    (void)copy;
    D = copy.D;
    K = copy.K;
    R = copy.R;
    P = copy.P;
  }
  CameraInfo &operator =(const CameraInfo &copy)
  {
    if (this == &copy)
      return *this;
    header = copy.header;
    height = copy.height;
    width = copy.width;
    roi = copy.roi;
    D = copy.D;
    K = copy.K;
    R = copy.R;
    P = copy.P;
    return *this;
  }
  virtual ~CameraInfo() 
  {
  }
  inline static std::string __s_getDataType() { return std::string("sensor_msgs/CameraInfo"); }
  inline static std::string __s_getMD5Sum() { return std::string("1b5cf7f984c229b6141ceb3a955aa18f"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# This message defines meta information for a camera. It should be in a\n"
    "# camera namespace and accompanied by up to 5 image topics named:\n"
    "# \n"
    "# image_raw, image, image_color, image_rect, and image_rect_color\n"
    "#\n"
    "# The meaning of the camera parameters are described in detail at\n"
    "# http://pr.willowgarage.com/wiki/Camera_Calibration.\n"
    "\n"
    "##########################\n"
    "# Image acquisition info #\n"
    "##########################\n"
    "\n"
    "# Time of image acquisition, camera coordinate frame ID\n"
    "Header header        # Header timestamp should be acquisition time of image\n"
    "                     # Header frame_id should be optical frame of camera\n"
    "                     # origin of frame should be optical center of camera\n"
    "                     # +x should point to the right in the image\n"
    "                     # +y should point down in the image\n"
    "                     # +z should point into to plane of the image\n"
    "\n"
    "# Camera resolution in pixels\n"
    "uint32 height\n"
    "uint32 width\n"
    "\n"
    "# Region of interest (subwindow of full camera resolution), if applicable\n"
    "RegionOfInterest roi\n"
    "\n"
    "##########################################\n"
    "# Internal parameters                    #\n"
    "# Used for warping to:                   #\n"
    "#  1. An undistorted image (just D and K)#\n"
    "#  2. A rectified image (D, K, R)        #\n"
    "# Users should not normally need these   #\n"
    "##########################################\n"
    "\n"
    "# Distortion parameters: k1, k2, t1, t2, k3\n"
    "# These model radial and tangential distortion of the camera.\n"
    "float64[5]  D # 5x1 vector\n"
    "\n"
    "# Intrinsic camera matrix for the raw (distorted) images\n"
    "# Projects 3D points in the camera coordinate frame to 2D pixel\n"
    "# coordinates using the focal lengths (fx, fy) and principal point\n"
    "# (cx, cy):\n"
    "#     [fx  0 cx]\n"
    "# K = [ 0 fy cy]\n"
    "#     [ 0  0  1]\n"
    "\n"
    "float64[9]  K # 3x3 row-major matrix\n"
    "\n"
    "\n"
    "# Rectification matrix (stereo cameras only)\n"
    "# A homography which takes an image to the ideal stereo image plane\n"
    "# so that epipolar lines in both stereo images are parallel.\n"
    "float64[9]  R # 3x3 row-major matrix\n"
    "\n"
    "######################################\n"
    "# Projection/camera matrix           #\n"
    "# This is a 3x4 projection matrix    #\n"
    "#   for going from 3D to 2D coords   #\n"
    "######################################\n"
    "\n"
    "# Projection/camera matrix\n"
    "# By convention, this matrix specifies the intrinsic (camera)\n"
    "#   matrix of the processed (rectified) image.\n"
    "# Upper 3x3 portion is the normal camera intrinsic matrix for\n"
    "#   the rectified image\n"
    "# Projects 3D points in the camera coordinate frame to 2D pixel\n"
    "# coordinates using the focal lengths (fx, fy) and principal point\n"
    "# (cx, cy):\n"
    "#              [fx  0 cx]\n"
    "# P[1:3,1:3] = [ 0 fy cy]\n"
    "#              [ 0  0  1]\n"
    "# For the right camera of a stereo pair, P[4,1] is the position\n"
    "#  of the right camera center in the left camera's frame, times\n"
    "#  the focal length fx.\n"
    "# \n"
    "# Given a 3D point q=[XYZ]^T in the left camera frame, the projection\n"
    "#  of the point onto the image is given by [uvw]^T = Pq, with x=u/w and y=v/w.\n"
    "#  This holds for both left and right images of a stereo pair.  \n"
    "#  For monocular cameras and the left image of a stereo pair, P[4,1] is always 0.\n"
    "\n"
    "float64[12] P # 3x4 row-major matrix\n"
    "\n"
    "================================================================================\n"
    "MSG: roslib/Header\n"
    "# Standard metadata for higher-level stamped data types.\n"
    "# This is generally used to communicate timestamped data \n"
    "# in a particular coordinate frame.\n"
    "# \n"
    "# sequence ID: consecutively increasing ID \n"
    "uint32 seq\n"
    "#Two-integer timestamp that is expressed as:\n"
    "# * stamp.secs: seconds (stamp_secs) since epoch\n"
    "# * stamp.nsecs: nanoseconds since stamp_secs\n"
    "# time-handling sugar is provided by the client library\n"
    "time stamp\n"
    "#Frame this data is associated with\n"
    "# 0: no frame\n"
    "# 1: global frame\n"
    "string frame_id\n"
    "\n"
    "================================================================================\n"
    "MSG: sensor_msgs/RegionOfInterest\n"
    "# This message is used to specify a region of interest within an image\n"
    "#\n"
    "# When used to specify the ROI setting of the camera when the image was taken,\n"
    "# the height and width fields should either match the height and width\n"
    "# fields for the associated image or be zeroes to indicate that the full image\n"
    "# was captured\n"
    "\n"
    "uint32 x_offset  #Leftmost pixel of the ROI (0 if the left edge of the image is included in the ROI)\n"
    "uint32 y_offset  #Topmost pixel of the ROI (0 if the top edge of the image is included in the ROI)\n"
    "uint32 height    #Height of ROI\n"
    "uint32 width     #Width of ROI\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline uint32_t get_D_size() const { return 5; }
  inline uint32_t get_K_size() const { return 9; }
  inline uint32_t get_R_size() const { return 9; }
  inline uint32_t get_P_size() const { return 12; }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += header.serializationLength(); // header
    __l += 4; // height
    __l += 4; // width
    __l += roi.serializationLength(); // roi
    __l += 5 * 8; // D
    __l += 9 * 8; // K
    __l += 9 * 8; // R
    __l += 12 * 8; // P
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
                             uint32_t seq) const
  {
    roslib::Header _ser_header = header;
    bool __reset_seq = (header.seq == 0);
    if (__reset_seq) _ser_header.seq = seq;
    write_ptr = _ser_header.serialize(write_ptr, seq);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, height);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, width);
    write_ptr = roi.serialize(write_ptr, seq);
    memcpy(write_ptr, &D[0], sizeof(double) * 5);
    write_ptr += sizeof(double) * 5;
    memcpy(write_ptr, &K[0], sizeof(double) * 9);
    write_ptr += sizeof(double) * 9;
    memcpy(write_ptr, &R[0], sizeof(double) * 9);
    write_ptr += sizeof(double) * 9;
    memcpy(write_ptr, &P[0], sizeof(double) * 12);
    write_ptr += sizeof(double) * 12;
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    read_ptr = header.deserialize(read_ptr);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, height);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, width);
    read_ptr = roi.deserialize(read_ptr);
    memcpy(&D[0], read_ptr, sizeof(double) * 5);
    read_ptr += sizeof(double) * 5;
    memcpy(&K[0], read_ptr, sizeof(double) * 9);
    read_ptr += sizeof(double) * 9;
    memcpy(&R[0], read_ptr, sizeof(double) * 9);
    read_ptr += sizeof(double) * 9;
    memcpy(&P[0], read_ptr, sizeof(double) * 12);
    read_ptr += sizeof(double) * 12;
    return read_ptr;
  }
};

typedef boost::shared_ptr<CameraInfo> CameraInfoPtr;
typedef boost::shared_ptr<CameraInfo const> CameraInfoConstPtr;


}

#endif
