/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/common_msgs/sensor_msgs/msg/CompressedImage.msg.  Do not edit! */
#ifndef SENSOR_MSGS_COMPRESSEDIMAGE_H
#define SENSOR_MSGS_COMPRESSEDIMAGE_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "roslib/Header.h"

namespace sensor_msgs
{

//! \htmlinclude CompressedImage.msg.html

class CompressedImage : public ros::Message
{
public:
  typedef boost::shared_ptr<CompressedImage> Ptr;
  typedef boost::shared_ptr<CompressedImage const> ConstPtr;

  typedef roslib::Header _header_type;
  typedef std::string _format_type;
  typedef std::vector<uint8_t> _data_type;

  roslib::Header header;
  std::string format;
  std::vector<uint8_t> data;

  CompressedImage() : ros::Message()
  {
  }
  CompressedImage(const CompressedImage &copy) : ros::Message(),
    header(copy.header),
    format(copy.format)
  {
    (void)copy;
    data = copy.data;
  }
  CompressedImage &operator =(const CompressedImage &copy)
  {
    if (this == &copy)
      return *this;
    data.clear();
    header = copy.header;
    format = copy.format;
    data = copy.data;
    return *this;
  }
  virtual ~CompressedImage() 
  {
    data.clear();
  }
  inline static std::string __s_getDataType() { return std::string("sensor_msgs/CompressedImage"); }
  inline static std::string __s_getMD5Sum() { return std::string("8f7a12909da2c9d3332d540a0977563f"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# This message contains a compressed image\n"
    "\n"
    "Header header        # Header timestamp should be acquisition time of image\n"
    "                     # Header frame_id should be optical frame of camera\n"
    "                     # origin of frame should be optical center of cameara\n"
    "                     # +x should point to the right in the image\n"
    "                     # +y should point down in the image\n"
    "                     # +z should point into to plane of the image\n"
    "\n"
    "string format        # Specifies the format of the data\n"
    "                     #   Acceptable values:\n"
    "                     #     jpeg, png\n"
    "uint8[] data         # Compressed image buffer\n"
    "\n"
    "================================================================================\n"
    "MSG: roslib/Header\n"
    "# Standard metadata for higher-level stamped data types.\n"
    "# This is generally used to communicate timestamped data \n"
    "# in a particular coordinate frame.\n"
    "# \n"
    "# sequence ID: consecutively increasing ID \n"
    "uint32 seq\n"
    "#Two-integer timestamp that is expressed as:\n"
    "# * stamp.secs: seconds (stamp_secs) since epoch\n"
    "# * stamp.nsecs: nanoseconds since stamp_secs\n"
    "# time-handling sugar is provided by the client library\n"
    "time stamp\n"
    "#Frame this data is associated with\n"
    "# 0: no frame\n"
    "# 1: global frame\n"
    "string frame_id\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  void set_data_size(uint32_t __ros_new_size)
  {
    this->data.resize(__ros_new_size);
  }
  inline uint32_t get_data_size() const { return data.size(); }
  inline void get_data_vec (std::vector<uint8_t> &__ros_vec) const
  {
    __ros_vec = this->data;
  }
  inline void set_data_vec(const std::vector<uint8_t> &__ros_vec)
  {
    this->data = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += header.serializationLength(); // header
    __l += 4 + format.length(); // format
    __l += 4 + (data.size() ? data.size() * 1 : 0); // data
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
                             uint32_t seq) const
  {
    roslib::Header _ser_header = header;
    bool __reset_seq = (header.seq == 0);
    if (__reset_seq) _ser_header.seq = seq;
    write_ptr = _ser_header.serialize(write_ptr, seq);
    unsigned __ros_format_len = format.length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_format_len);
    SROS_SERIALIZE_BUFFER(write_ptr, format.c_str(), __ros_format_len);
    uint32_t __data_size = data.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __data_size);
    memcpy(write_ptr, &data[0], sizeof(uint8_t) * __data_size);
    write_ptr += sizeof(uint8_t) * __data_size;
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    read_ptr = header.deserialize(read_ptr);
    unsigned __ros_format_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_format_len);
    format = std::string((const char *)read_ptr, __ros_format_len);
    read_ptr += __ros_format_len;
    uint32_t __data_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __data_size);
    set_data_size(__data_size);
    memcpy(&data[0], read_ptr, sizeof(uint8_t) * __data_size);
    read_ptr += sizeof(uint8_t) * __data_size;
    return read_ptr;
  }
};

typedef boost::shared_ptr<CompressedImage> CompressedImagePtr;
typedef boost::shared_ptr<CompressedImage const> CompressedImageConstPtr;


}

#endif
