/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/common_msgs/sensor_msgs/msg/Image.msg.  Do not edit! */
#ifndef SENSOR_MSGS_IMAGE_H
#define SENSOR_MSGS_IMAGE_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "roslib/Header.h"

namespace sensor_msgs
{

//! \htmlinclude Image.msg.html

class Image : public ros::Message
{
public:
  typedef boost::shared_ptr<Image> Ptr;
  typedef boost::shared_ptr<Image const> ConstPtr;

  typedef roslib::Header _header_type;
  typedef uint32_t _height_type;
  typedef uint32_t _width_type;
  typedef std::string _encoding_type;
  typedef uint8_t _is_bigendian_type;
  typedef uint32_t _step_type;
  typedef std::vector<uint8_t> _data_type;

  roslib::Header header;
  uint32_t height;
  uint32_t width;
  std::string encoding;
  uint8_t is_bigendian;
  uint32_t step;
  std::vector<uint8_t> data;

  Image() : ros::Message(),
    height(0),
    width(0),
    is_bigendian(0),
    step(0)
  {
  }
  Image(const Image &copy) : ros::Message(),
    header(copy.header),
    height(copy.height),
    width(copy.width),
    encoding(copy.encoding),
    is_bigendian(copy.is_bigendian),
    step(copy.step)
  {
    (void)copy;
    data = copy.data;
  }
  Image &operator =(const Image &copy)
  {
    if (this == &copy)
      return *this;
    data.clear();
    header = copy.header;
    height = copy.height;
    width = copy.width;
    encoding = copy.encoding;
    is_bigendian = copy.is_bigendian;
    step = copy.step;
    data = copy.data;
    return *this;
  }
  virtual ~Image() 
  {
    data.clear();
  }
  inline static std::string __s_getDataType() { return std::string("sensor_msgs/Image"); }
  inline static std::string __s_getMD5Sum() { return std::string("060021388200f6f0f447d0fcd9c64743"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# This message contains an uncompressed image\n"
    "# (0, 0) is at top-left corner of image\n"
    "#\n"
    "\n"
    "Header header        # Header timestamp should be acquisition time of image\n"
    "                     # Header frame_id should be optical frame of camera\n"
    "                     # origin of frame should be optical center of cameara\n"
    "                     # +x should point to the right in the image\n"
    "                     # +y should point down in the image\n"
    "                     # +z should point into to plane of the image\n"
    "                     # If the frame_id here and the frame_id of the CameraInfo\n"
    "                     # message associated with the image conflict\n"
    "                     # the behavior is undefined\n"
    "\n"
    "uint32 height         # image height, that is, number of rows\n"
    "uint32 width          # image width, that is, number of columns\n"
    "\n"
    "# The legal values for encoding are in file src/image_encodings.cpp\n"
    "# If you want to standardize a new string format, join\n"
    "# ros-users@lists.sourceforge.net and send an email proposing a new encoding.\n"
    "\n"
    "string encoding       # Encoding of pixels -- channel meaning, ordering, size\n"
    "                      # taken from the list of strings in src/image_encodings.cpp\n"
    "\n"
    "uint8 is_bigendian    # is this data bigendian?\n"
    "uint32 step           # Full row length in bytes\n"
    "uint8[] data          # actual matrix data, size is (step * rows)\n"
    "\n"
    "================================================================================\n"
    "MSG: roslib/Header\n"
    "# Standard metadata for higher-level stamped data types.\n"
    "# This is generally used to communicate timestamped data \n"
    "# in a particular coordinate frame.\n"
    "# \n"
    "# sequence ID: consecutively increasing ID \n"
    "uint32 seq\n"
    "#Two-integer timestamp that is expressed as:\n"
    "# * stamp.secs: seconds (stamp_secs) since epoch\n"
    "# * stamp.nsecs: nanoseconds since stamp_secs\n"
    "# time-handling sugar is provided by the client library\n"
    "time stamp\n"
    "#Frame this data is associated with\n"
    "# 0: no frame\n"
    "# 1: global frame\n"
    "string frame_id\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  void set_data_size(uint32_t __ros_new_size)
  {
    this->data.resize(__ros_new_size);
  }
  inline uint32_t get_data_size() const { return data.size(); }
  inline void get_data_vec (std::vector<uint8_t> &__ros_vec) const
  {
    __ros_vec = this->data;
  }
  inline void set_data_vec(const std::vector<uint8_t> &__ros_vec)
  {
    this->data = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += header.serializationLength(); // header
    __l += 4; // height
    __l += 4; // width
    __l += 4 + encoding.length(); // encoding
    __l += 1; // is_bigendian
    __l += 4; // step
    __l += 4 + (data.size() ? data.size() * 1 : 0); // data
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
                             uint32_t seq) const
  {
    roslib::Header _ser_header = header;
    bool __reset_seq = (header.seq == 0);
    if (__reset_seq) _ser_header.seq = seq;
    write_ptr = _ser_header.serialize(write_ptr, seq);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, height);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, width);
    unsigned __ros_encoding_len = encoding.length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_encoding_len);
    SROS_SERIALIZE_BUFFER(write_ptr, encoding.c_str(), __ros_encoding_len);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, is_bigendian);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, step);
    uint32_t __data_size = data.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __data_size);
    memcpy(write_ptr, &data[0], sizeof(uint8_t) * __data_size);
    write_ptr += sizeof(uint8_t) * __data_size;
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    read_ptr = header.deserialize(read_ptr);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, height);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, width);
    unsigned __ros_encoding_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_encoding_len);
    encoding = std::string((const char *)read_ptr, __ros_encoding_len);
    read_ptr += __ros_encoding_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, is_bigendian);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, step);
    uint32_t __data_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __data_size);
    set_data_size(__data_size);
    memcpy(&data[0], read_ptr, sizeof(uint8_t) * __data_size);
    read_ptr += sizeof(uint8_t) * __data_size;
    return read_ptr;
  }
};

typedef boost::shared_ptr<Image> ImagePtr;
typedef boost::shared_ptr<Image const> ImageConstPtr;


}

#endif
