/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/common_msgs/sensor_msgs/msg/Imu.msg.  Do not edit! */
#ifndef SENSOR_MSGS_IMU_H
#define SENSOR_MSGS_IMU_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "roslib/Header.h"
#include "geometry_msgs/Quaternion.h"
#include "geometry_msgs/Vector3.h"

namespace sensor_msgs
{

//! \htmlinclude Imu.msg.html

class Imu : public ros::Message
{
public:
  typedef boost::shared_ptr<Imu> Ptr;
  typedef boost::shared_ptr<Imu const> ConstPtr;

  typedef roslib::Header _header_type;
  typedef geometry_msgs::Quaternion _orientation_type;
  typedef boost::array<double, 9> _orientation_covariance_type;
  typedef geometry_msgs::Vector3 _angular_velocity_type;
  typedef boost::array<double, 9> _angular_velocity_covariance_type;
  typedef geometry_msgs::Vector3 _linear_acceleration_type;
  typedef boost::array<double, 9> _linear_acceleration_covariance_type;

  roslib::Header header;
  geometry_msgs::Quaternion orientation;
  boost::array<double, 9> orientation_covariance;
  geometry_msgs::Vector3 angular_velocity;
  boost::array<double, 9> angular_velocity_covariance;
  geometry_msgs::Vector3 linear_acceleration;
  boost::array<double, 9> linear_acceleration_covariance;

  Imu() : ros::Message()
  {
    orientation_covariance.assign(0);
    angular_velocity_covariance.assign(0);
    linear_acceleration_covariance.assign(0);
  }
  Imu(const Imu &copy) : ros::Message(),
    header(copy.header),
    orientation(copy.orientation),
    angular_velocity(copy.angular_velocity),
    linear_acceleration(copy.linear_acceleration)
  {
    (void)copy;
    orientation_covariance = copy.orientation_covariance;
    angular_velocity_covariance = copy.angular_velocity_covariance;
    linear_acceleration_covariance = copy.linear_acceleration_covariance;
  }
  Imu &operator =(const Imu &copy)
  {
    if (this == &copy)
      return *this;
    header = copy.header;
    orientation = copy.orientation;
    orientation_covariance = copy.orientation_covariance;
    angular_velocity = copy.angular_velocity;
    angular_velocity_covariance = copy.angular_velocity_covariance;
    linear_acceleration = copy.linear_acceleration;
    linear_acceleration_covariance = copy.linear_acceleration_covariance;
    return *this;
  }
  virtual ~Imu() 
  {
  }
  inline static std::string __s_getDataType() { return std::string("sensor_msgs/Imu"); }
  inline static std::string __s_getMD5Sum() { return std::string("6a62c6daae103f4ff57a132d6f95cec2"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# This is a message to hold data from an IMU (Inertial Measurement Unit)\n"
    "#\n"
    "# Accelerations should be in m/s^2 (not in g's), and rotational velocity should be in rad/sec\n"
    "#\n"
    "# If the covariance of the measurement is known, it should be filled in (if all you know is the variance of each measurement, e.g. from the datasheet, just put those along the diagonal)\n"
    "# A covariance matrix of all zeros will be interpreted as \"covariance unknown\", and to use the data a covariance will have to be assumed or gotten from some other source\n"
    "#\n"
    "# If you have no estimate for one of the data elements (e.g. your IMU doesn't produce an orientation estimate), please set element 0 of the associated covariance matrix to -1\n"
    "# If you are interpreting this message, please check for a value of -1 in the first element of each covariance matrix, and disregard the associated estimate.\n"
    "\n"
    "Header header\n"
    "\n"
    "geometry_msgs/Quaternion orientation\n"
    "float64[9] orientation_covariance # Row major about x, y, z axes\n"
    "\n"
    "geometry_msgs/Vector3 angular_velocity\n"
    "float64[9] angular_velocity_covariance # Row major about x, y, z axes\n"
    "\n"
    "geometry_msgs/Vector3 linear_acceleration\n"
    "float64[9] linear_acceleration_covariance # Row major x, y z \n"
    "\n"
    "================================================================================\n"
    "MSG: roslib/Header\n"
    "# Standard metadata for higher-level stamped data types.\n"
    "# This is generally used to communicate timestamped data \n"
    "# in a particular coordinate frame.\n"
    "# \n"
    "# sequence ID: consecutively increasing ID \n"
    "uint32 seq\n"
    "#Two-integer timestamp that is expressed as:\n"
    "# * stamp.secs: seconds (stamp_secs) since epoch\n"
    "# * stamp.nsecs: nanoseconds since stamp_secs\n"
    "# time-handling sugar is provided by the client library\n"
    "time stamp\n"
    "#Frame this data is associated with\n"
    "# 0: no frame\n"
    "# 1: global frame\n"
    "string frame_id\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Quaternion\n"
    "# This represents an orientation in free space in quaternion form.\n"
    "\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "float64 w\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Vector3\n"
    "# This represents a vector in free space. \n"
    "\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline uint32_t get_orientation_covariance_size() const { return 9; }
  inline uint32_t get_angular_velocity_covariance_size() const { return 9; }
  inline uint32_t get_linear_acceleration_covariance_size() const { return 9; }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += header.serializationLength(); // header
    __l += orientation.serializationLength(); // orientation
    __l += 9 * 8; // orientation_covariance
    __l += angular_velocity.serializationLength(); // angular_velocity
    __l += 9 * 8; // angular_velocity_covariance
    __l += linear_acceleration.serializationLength(); // linear_acceleration
    __l += 9 * 8; // linear_acceleration_covariance
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
                             uint32_t seq) const
  {
    roslib::Header _ser_header = header;
    bool __reset_seq = (header.seq == 0);
    if (__reset_seq) _ser_header.seq = seq;
    write_ptr = _ser_header.serialize(write_ptr, seq);
    write_ptr = orientation.serialize(write_ptr, seq);
    memcpy(write_ptr, &orientation_covariance[0], sizeof(double) * 9);
    write_ptr += sizeof(double) * 9;
    write_ptr = angular_velocity.serialize(write_ptr, seq);
    memcpy(write_ptr, &angular_velocity_covariance[0], sizeof(double) * 9);
    write_ptr += sizeof(double) * 9;
    write_ptr = linear_acceleration.serialize(write_ptr, seq);
    memcpy(write_ptr, &linear_acceleration_covariance[0], sizeof(double) * 9);
    write_ptr += sizeof(double) * 9;
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    read_ptr = header.deserialize(read_ptr);
    read_ptr = orientation.deserialize(read_ptr);
    memcpy(&orientation_covariance[0], read_ptr, sizeof(double) * 9);
    read_ptr += sizeof(double) * 9;
    read_ptr = angular_velocity.deserialize(read_ptr);
    memcpy(&angular_velocity_covariance[0], read_ptr, sizeof(double) * 9);
    read_ptr += sizeof(double) * 9;
    read_ptr = linear_acceleration.deserialize(read_ptr);
    memcpy(&linear_acceleration_covariance[0], read_ptr, sizeof(double) * 9);
    read_ptr += sizeof(double) * 9;
    return read_ptr;
  }
};

typedef boost::shared_ptr<Imu> ImuPtr;
typedef boost::shared_ptr<Imu const> ImuConstPtr;


}

#endif
