/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/common_msgs/sensor_msgs/msg/JointState.msg.  Do not edit! */
#ifndef SENSOR_MSGS_JOINTSTATE_H
#define SENSOR_MSGS_JOINTSTATE_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "roslib/Header.h"

namespace sensor_msgs
{

//! \htmlinclude JointState.msg.html

class JointState : public ros::Message
{
public:
  typedef boost::shared_ptr<JointState> Ptr;
  typedef boost::shared_ptr<JointState const> ConstPtr;

  typedef roslib::Header _header_type;
  typedef std::vector<std::string> _name_type;
  typedef std::vector<double> _position_type;
  typedef std::vector<double> _velocity_type;
  typedef std::vector<double> _effort_type;

  roslib::Header header;
  std::vector<std::string> name;
  std::vector<double> position;
  std::vector<double> velocity;
  std::vector<double> effort;

  JointState() : ros::Message()
  {
  }
  JointState(const JointState &copy) : ros::Message(),
    header(copy.header)
  {
    (void)copy;
    name = copy.name;
    position = copy.position;
    velocity = copy.velocity;
    effort = copy.effort;
  }
  JointState &operator =(const JointState &copy)
  {
    if (this == &copy)
      return *this;
    name.clear();
    position.clear();
    velocity.clear();
    effort.clear();
    header = copy.header;
    name = copy.name;
    position = copy.position;
    velocity = copy.velocity;
    effort = copy.effort;
    return *this;
  }
  virtual ~JointState() 
  {
    name.clear();
    position.clear();
    velocity.clear();
    effort.clear();
  }
  inline static std::string __s_getDataType() { return std::string("sensor_msgs/JointState"); }
  inline static std::string __s_getMD5Sum() { return std::string("3066dcd76a6cfaef579bd0f34173e9fd"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# This is a message that holds data to describe the state of a set of torque controlled joints. \n"
    "#\n"
    "# The state of each joint is defined by:\n"
    "#  * the position of the joint, \n"
    "#  * the velocity of the joint and \n"
    "#  * the effort that is applied in the joint.\n"
    "#\n"
    "# Each joint is uniquely identified by its name\n"
    "# The header specifies the time at which the joint states were recorded. All the joint states\n"
    "# in one message have to be recorded at the same time.\n"
    "#\n"
    "# This message consists of a multiple arrays, one for each part of the joint state. \n"
    "# The goal is to make each of the fields optional. When e.g. your joints have no\n"
    "# effort associated with them, you can leave the effort array empty. \n"
    "#\n"
    "# All arrays in this message should have the same size, or be empty.\n"
    "# This is the only way to uniquely associate the joint name with the correct\n"
    "# states.\n"
    "\n"
    "\n"
    "Header header\n"
    "\n"
    "string[] name\n"
    "float64[] position\n"
    "float64[] velocity\n"
    "float64[] effort\n"
    "\n"
    "================================================================================\n"
    "MSG: roslib/Header\n"
    "# Standard metadata for higher-level stamped data types.\n"
    "# This is generally used to communicate timestamped data \n"
    "# in a particular coordinate frame.\n"
    "# \n"
    "# sequence ID: consecutively increasing ID \n"
    "uint32 seq\n"
    "#Two-integer timestamp that is expressed as:\n"
    "# * stamp.secs: seconds (stamp_secs) since epoch\n"
    "# * stamp.nsecs: nanoseconds since stamp_secs\n"
    "# time-handling sugar is provided by the client library\n"
    "time stamp\n"
    "#Frame this data is associated with\n"
    "# 0: no frame\n"
    "# 1: global frame\n"
    "string frame_id\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  void set_name_size(uint32_t __ros_new_size)
  {
    this->name.resize(__ros_new_size);
  }
  inline uint32_t get_name_size() const { return name.size(); }
  uint32_t calc_name_array_serialization_len() const
  {
    uint32_t l = 0;
    uint32_t name_size = name.size();
    for (size_t i = 0; i < name_size; i++)
      l += 4 + name[i].length();
    return l;
  }
  inline void get_name_vec (std::vector<std::string> &__ros_vec) const
  {
    __ros_vec = this->name;
  }
  inline void set_name_vec(const std::vector<std::string> &__ros_vec)
  {
    this->name = __ros_vec;
  }
  void set_position_size(uint32_t __ros_new_size)
  {
    this->position.resize(__ros_new_size);
  }
  inline uint32_t get_position_size() const { return position.size(); }
  inline void get_position_vec (std::vector<double> &__ros_vec) const
  {
    __ros_vec = this->position;
  }
  inline void set_position_vec(const std::vector<double> &__ros_vec)
  {
    this->position = __ros_vec;
  }
  void set_velocity_size(uint32_t __ros_new_size)
  {
    this->velocity.resize(__ros_new_size);
  }
  inline uint32_t get_velocity_size() const { return velocity.size(); }
  inline void get_velocity_vec (std::vector<double> &__ros_vec) const
  {
    __ros_vec = this->velocity;
  }
  inline void set_velocity_vec(const std::vector<double> &__ros_vec)
  {
    this->velocity = __ros_vec;
  }
  void set_effort_size(uint32_t __ros_new_size)
  {
    this->effort.resize(__ros_new_size);
  }
  inline uint32_t get_effort_size() const { return effort.size(); }
  inline void get_effort_vec (std::vector<double> &__ros_vec) const
  {
    __ros_vec = this->effort;
  }
  inline void set_effort_vec(const std::vector<double> &__ros_vec)
  {
    this->effort = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += header.serializationLength(); // header
    __l += 4 + calc_name_array_serialization_len(); // name
    __l += 4 + (position.size() ? position.size() * 8 : 0); // position
    __l += 4 + (velocity.size() ? velocity.size() * 8 : 0); // velocity
    __l += 4 + (effort.size() ? effort.size() * 8 : 0); // effort
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
                             uint32_t seq) const
  {
    roslib::Header _ser_header = header;
    bool __reset_seq = (header.seq == 0);
    if (__reset_seq) _ser_header.seq = seq;
    write_ptr = _ser_header.serialize(write_ptr, seq);
    uint32_t __name_size = name.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __name_size);
    for (size_t i = 0; i < __name_size; i++)
    {
      unsigned __ros_name_i__len = name[i].length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_name_i__len);
    SROS_SERIALIZE_BUFFER(write_ptr, name[i].c_str(), __ros_name_i__len);
    }
    uint32_t __position_size = position.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __position_size);
    memcpy(write_ptr, &position[0], sizeof(double) * __position_size);
    write_ptr += sizeof(double) * __position_size;
    uint32_t __velocity_size = velocity.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __velocity_size);
    memcpy(write_ptr, &velocity[0], sizeof(double) * __velocity_size);
    write_ptr += sizeof(double) * __velocity_size;
    uint32_t __effort_size = effort.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __effort_size);
    memcpy(write_ptr, &effort[0], sizeof(double) * __effort_size);
    write_ptr += sizeof(double) * __effort_size;
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    read_ptr = header.deserialize(read_ptr);
    uint32_t __name_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __name_size);
    set_name_size(__name_size);
    for (size_t i = 0; i < __name_size; i++)
    {
      unsigned __ros_name_i__len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_name_i__len);
    name[i] = std::string((const char *)read_ptr, __ros_name_i__len);
    read_ptr += __ros_name_i__len;
    }
    uint32_t __position_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __position_size);
    set_position_size(__position_size);
    memcpy(&position[0], read_ptr, sizeof(double) * __position_size);
    read_ptr += sizeof(double) * __position_size;
    uint32_t __velocity_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __velocity_size);
    set_velocity_size(__velocity_size);
    memcpy(&velocity[0], read_ptr, sizeof(double) * __velocity_size);
    read_ptr += sizeof(double) * __velocity_size;
    uint32_t __effort_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __effort_size);
    set_effort_size(__effort_size);
    memcpy(&effort[0], read_ptr, sizeof(double) * __effort_size);
    read_ptr += sizeof(double) * __effort_size;
    return read_ptr;
  }
};

typedef boost::shared_ptr<JointState> JointStatePtr;
typedef boost::shared_ptr<JointState const> JointStateConstPtr;


}

#endif
