/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/common_msgs/sensor_msgs/msg/LaserScan.msg.  Do not edit! */
#ifndef SENSOR_MSGS_LASERSCAN_H
#define SENSOR_MSGS_LASERSCAN_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "roslib/Header.h"

namespace sensor_msgs
{

//! \htmlinclude LaserScan.msg.html

class LaserScan : public ros::Message
{
public:
  typedef boost::shared_ptr<LaserScan> Ptr;
  typedef boost::shared_ptr<LaserScan const> ConstPtr;

  typedef roslib::Header _header_type;
  typedef float _angle_min_type;
  typedef float _angle_max_type;
  typedef float _angle_increment_type;
  typedef float _time_increment_type;
  typedef float _scan_time_type;
  typedef float _range_min_type;
  typedef float _range_max_type;
  typedef std::vector<float> _ranges_type;
  typedef std::vector<float> _intensities_type;

  roslib::Header header;
  float angle_min;
  float angle_max;
  float angle_increment;
  float time_increment;
  float scan_time;
  float range_min;
  float range_max;
  std::vector<float> ranges;
  std::vector<float> intensities;

  LaserScan() : ros::Message(),
    angle_min(0),
    angle_max(0),
    angle_increment(0),
    time_increment(0),
    scan_time(0),
    range_min(0),
    range_max(0)
  {
  }
  LaserScan(const LaserScan &copy) : ros::Message(),
    header(copy.header),
    angle_min(copy.angle_min),
    angle_max(copy.angle_max),
    angle_increment(copy.angle_increment),
    time_increment(copy.time_increment),
    scan_time(copy.scan_time),
    range_min(copy.range_min),
    range_max(copy.range_max)
  {
    (void)copy;
    ranges = copy.ranges;
    intensities = copy.intensities;
  }
  LaserScan &operator =(const LaserScan &copy)
  {
    if (this == &copy)
      return *this;
    ranges.clear();
    intensities.clear();
    header = copy.header;
    angle_min = copy.angle_min;
    angle_max = copy.angle_max;
    angle_increment = copy.angle_increment;
    time_increment = copy.time_increment;
    scan_time = copy.scan_time;
    range_min = copy.range_min;
    range_max = copy.range_max;
    ranges = copy.ranges;
    intensities = copy.intensities;
    return *this;
  }
  virtual ~LaserScan() 
  {
    ranges.clear();
    intensities.clear();
  }
  inline static std::string __s_getDataType() { return std::string("sensor_msgs/LaserScan"); }
  inline static std::string __s_getMD5Sum() { return std::string("90c7ef2dc6895d81024acba2ac42f369"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# Single scan from a planar laser range-finder\n"
    "#\n"
    "# If you have another ranging device with different behavior (e.g. a sonar\n"
    "# array), please find or create a different message, since applications\n"
    "# will make fairly laser-specific assumptions about this data\n"
    "\n"
    "Header header            # timestamp in the header is the acquisition time of \n"
    "                         # the first ray in the scan.\n"
    "                         #\n"
    "                         # in frame frame_id, angles are measured around \n"
    "                         # the positive Z axis (counterclockwise, if Z is up)\n"
    "                         # with zero angle being forward along the x axis\n"
    "                         \n"
    "float32 angle_min        # start angle of the scan [rad]\n"
    "float32 angle_max        # end angle of the scan [rad]\n"
    "float32 angle_increment  # angular distance between measurements [rad]\n"
    "\n"
    "float32 time_increment   # time between measurements [seconds] - if your scanner\n"
    "                         # is moving, this will be used in interpolating position\n"
    "                         # of 3d points\n"
    "float32 scan_time        # time between scans [seconds]\n"
    "\n"
    "float32 range_min        # minimum range value [m]\n"
    "float32 range_max        # maximum range value [m]\n"
    "\n"
    "float32[] ranges         # range data [m] (Note: values < range_min or > range_max should be discarded)\n"
    "float32[] intensities    # intensity data [device-specific units].  If your\n"
    "                         # device does not provide intensities, please leave\n"
    "                         # the array empty.\n"
    "\n"
    "================================================================================\n"
    "MSG: roslib/Header\n"
    "# Standard metadata for higher-level stamped data types.\n"
    "# This is generally used to communicate timestamped data \n"
    "# in a particular coordinate frame.\n"
    "# \n"
    "# sequence ID: consecutively increasing ID \n"
    "uint32 seq\n"
    "#Two-integer timestamp that is expressed as:\n"
    "# * stamp.secs: seconds (stamp_secs) since epoch\n"
    "# * stamp.nsecs: nanoseconds since stamp_secs\n"
    "# time-handling sugar is provided by the client library\n"
    "time stamp\n"
    "#Frame this data is associated with\n"
    "# 0: no frame\n"
    "# 1: global frame\n"
    "string frame_id\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  void set_ranges_size(uint32_t __ros_new_size)
  {
    this->ranges.resize(__ros_new_size);
  }
  inline uint32_t get_ranges_size() const { return ranges.size(); }
  inline void get_ranges_vec (std::vector<float> &__ros_vec) const
  {
    __ros_vec = this->ranges;
  }
  inline void set_ranges_vec(const std::vector<float> &__ros_vec)
  {
    this->ranges = __ros_vec;
  }
  void set_intensities_size(uint32_t __ros_new_size)
  {
    this->intensities.resize(__ros_new_size);
  }
  inline uint32_t get_intensities_size() const { return intensities.size(); }
  inline void get_intensities_vec (std::vector<float> &__ros_vec) const
  {
    __ros_vec = this->intensities;
  }
  inline void set_intensities_vec(const std::vector<float> &__ros_vec)
  {
    this->intensities = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += header.serializationLength(); // header
    __l += 4; // angle_min
    __l += 4; // angle_max
    __l += 4; // angle_increment
    __l += 4; // time_increment
    __l += 4; // scan_time
    __l += 4; // range_min
    __l += 4; // range_max
    __l += 4 + (ranges.size() ? ranges.size() * 4 : 0); // ranges
    __l += 4 + (intensities.size() ? intensities.size() * 4 : 0); // intensities
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
                             uint32_t seq) const
  {
    roslib::Header _ser_header = header;
    bool __reset_seq = (header.seq == 0);
    if (__reset_seq) _ser_header.seq = seq;
    write_ptr = _ser_header.serialize(write_ptr, seq);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, angle_min);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, angle_max);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, angle_increment);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, time_increment);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, scan_time);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, range_min);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, range_max);
    uint32_t __ranges_size = ranges.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ranges_size);
    memcpy(write_ptr, &ranges[0], sizeof(float) * __ranges_size);
    write_ptr += sizeof(float) * __ranges_size;
    uint32_t __intensities_size = intensities.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __intensities_size);
    memcpy(write_ptr, &intensities[0], sizeof(float) * __intensities_size);
    write_ptr += sizeof(float) * __intensities_size;
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    read_ptr = header.deserialize(read_ptr);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, angle_min);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, angle_max);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, angle_increment);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, time_increment);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, scan_time);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, range_min);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, range_max);
    uint32_t __ranges_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ranges_size);
    set_ranges_size(__ranges_size);
    memcpy(&ranges[0], read_ptr, sizeof(float) * __ranges_size);
    read_ptr += sizeof(float) * __ranges_size;
    uint32_t __intensities_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __intensities_size);
    set_intensities_size(__intensities_size);
    memcpy(&intensities[0], read_ptr, sizeof(float) * __intensities_size);
    read_ptr += sizeof(float) * __intensities_size;
    return read_ptr;
  }
};

typedef boost::shared_ptr<LaserScan> LaserScanPtr;
typedef boost::shared_ptr<LaserScan const> LaserScanConstPtr;


}

#endif
