/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/common_msgs/sensor_msgs/msg/PointCloud.msg.  Do not edit! */
#ifndef SENSOR_MSGS_POINTCLOUD_H
#define SENSOR_MSGS_POINTCLOUD_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "roslib/Header.h"
#include "geometry_msgs/Point32.h"
#include "sensor_msgs/ChannelFloat32.h"

namespace sensor_msgs
{

//! \htmlinclude PointCloud.msg.html

class PointCloud : public ros::Message
{
public:
  typedef boost::shared_ptr<PointCloud> Ptr;
  typedef boost::shared_ptr<PointCloud const> ConstPtr;

  typedef roslib::Header _header_type;
  typedef std::vector<geometry_msgs::Point32> _points_type;
  typedef std::vector<sensor_msgs::ChannelFloat32> _channels_type;

  roslib::Header header;
  std::vector<geometry_msgs::Point32> points;
  std::vector<sensor_msgs::ChannelFloat32> channels;

  PointCloud() : ros::Message()
  {
  }
  PointCloud(const PointCloud &copy) : ros::Message(),
    header(copy.header)
  {
    (void)copy;
    points = copy.points;
    channels = copy.channels;
  }
  PointCloud &operator =(const PointCloud &copy)
  {
    if (this == &copy)
      return *this;
    points.clear();
    channels.clear();
    header = copy.header;
    points = copy.points;
    channels = copy.channels;
    return *this;
  }
  virtual ~PointCloud() 
  {
    points.clear();
    channels.clear();
  }
  inline static std::string __s_getDataType() { return std::string("sensor_msgs/PointCloud"); }
  inline static std::string __s_getMD5Sum() { return std::string("d8e9c3f5afbdd8a130fd1d2763945fca"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "#This message holds a collection of 3d points, plus optional additional information about each point.\n"
    "#Each Point32 should be interpreted as a 3d point in the frame given in the header\n"
    "\n"
    "Header header\n"
    "geometry_msgs/Point32[] points  #Array of 3d points\n"
    "ChannelFloat32[] channels       #Each channel should have the same number of elements as points array, and the data in each channel should correspond 1:1 with each point\n"
    "\n"
    "================================================================================\n"
    "MSG: roslib/Header\n"
    "# Standard metadata for higher-level stamped data types.\n"
    "# This is generally used to communicate timestamped data \n"
    "# in a particular coordinate frame.\n"
    "# \n"
    "# sequence ID: consecutively increasing ID \n"
    "uint32 seq\n"
    "#Two-integer timestamp that is expressed as:\n"
    "# * stamp.secs: seconds (stamp_secs) since epoch\n"
    "# * stamp.nsecs: nanoseconds since stamp_secs\n"
    "# time-handling sugar is provided by the client library\n"
    "time stamp\n"
    "#Frame this data is associated with\n"
    "# 0: no frame\n"
    "# 1: global frame\n"
    "string frame_id\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Point32\n"
    "# This contains the position of a point in free space(with 32 bits of precision).\n"
    "# It is recommeded to use Point wherever possible instead of Point32.  \n"
    "# \n"
    "# This recommendation is to promote interoperability.  \n"
    "#\n"
    "# This message is designed to take up less space when sending\n"
    "# lots of points at once, as in the case of a PointCloud.  \n"
    "\n"
    "float32 x\n"
    "float32 y\n"
    "float32 z\n"
    "================================================================================\n"
    "MSG: sensor_msgs/ChannelFloat32\n"
    "#This message is used by the PointCloud message to hold optional data associated with each point in the cloud\n"
    "#The length of the values array should be the same as the length of the points array in the PointCloud, and each value should be associated with the corresponding point\n"
    "\n"
    "string name       #channel name should give semantics of the channel (e.g. \"intensity\" instead of \"value\")\n"
    "float32[] values  #values array should have same number of elements as the associated PointCloud\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  void set_points_size(uint32_t __ros_new_size)
  {
    this->points.resize(__ros_new_size);
  }
  inline uint32_t get_points_size() const { return points.size(); }
  inline void get_points_vec (std::vector<geometry_msgs::Point32> &__ros_vec) const
  {
    __ros_vec = this->points;
  }
  inline void set_points_vec(const std::vector<geometry_msgs::Point32> &__ros_vec)
  {
    this->points = __ros_vec;
  }
  void set_channels_size(uint32_t __ros_new_size)
  {
    this->channels.resize(__ros_new_size);
  }
  inline uint32_t get_channels_size() const { return channels.size(); }
  uint32_t calc_channels_array_serialization_len() const
  {
    uint32_t l = 0;
    uint32_t channels_size = channels.size();
    for (size_t i = 0; i < channels_size; i++)
      l += channels[i].serializationLength();
    return l;
  }
  inline void get_channels_vec (std::vector<sensor_msgs::ChannelFloat32> &__ros_vec) const
  {
    __ros_vec = this->channels;
  }
  inline void set_channels_vec(const std::vector<sensor_msgs::ChannelFloat32> &__ros_vec)
  {
    this->channels = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += header.serializationLength(); // header
    __l += 4 + (points.size() ? points.size() * points[0].serializationLength() : 0); // points
    __l += 4 + calc_channels_array_serialization_len(); // channels
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
                             uint32_t seq) const
  {
    roslib::Header _ser_header = header;
    bool __reset_seq = (header.seq == 0);
    if (__reset_seq) _ser_header.seq = seq;
    write_ptr = _ser_header.serialize(write_ptr, seq);
    uint32_t __points_size = points.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __points_size);
    for (size_t i = 0; i < __points_size; i++)
      write_ptr = points[i].serialize(write_ptr, seq);
    uint32_t __channels_size = channels.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __channels_size);
    for (size_t i = 0; i < __channels_size; i++)
      write_ptr = channels[i].serialize(write_ptr, seq);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    read_ptr = header.deserialize(read_ptr);
    uint32_t __points_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __points_size);
    set_points_size(__points_size);
    for (size_t i = 0; i < __points_size; i++)
      read_ptr = points[i].deserialize(read_ptr);
    uint32_t __channels_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __channels_size);
    set_channels_size(__channels_size);
    for (size_t i = 0; i < __channels_size; i++)
      read_ptr = channels[i].deserialize(read_ptr);
    return read_ptr;
  }
};

typedef boost::shared_ptr<PointCloud> PointCloudPtr;
typedef boost::shared_ptr<PointCloud const> PointCloudConstPtr;


}

#endif
