/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/common_msgs/sensor_msgs/msg/RegionOfInterest.msg.  Do not edit! */
#ifndef SENSOR_MSGS_REGIONOFINTEREST_H
#define SENSOR_MSGS_REGIONOFINTEREST_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

namespace sensor_msgs
{

//! \htmlinclude RegionOfInterest.msg.html

class RegionOfInterest : public ros::Message
{
public:
  typedef boost::shared_ptr<RegionOfInterest> Ptr;
  typedef boost::shared_ptr<RegionOfInterest const> ConstPtr;

  typedef uint32_t _x_offset_type;
  typedef uint32_t _y_offset_type;
  typedef uint32_t _height_type;
  typedef uint32_t _width_type;

  uint32_t x_offset;
  uint32_t y_offset;
  uint32_t height;
  uint32_t width;

  RegionOfInterest() : ros::Message(),
    x_offset(0),
    y_offset(0),
    height(0),
    width(0)
  {
  }
  RegionOfInterest(const RegionOfInterest &copy) : ros::Message(),
    x_offset(copy.x_offset),
    y_offset(copy.y_offset),
    height(copy.height),
    width(copy.width)
  {
    (void)copy;
  }
  RegionOfInterest &operator =(const RegionOfInterest &copy)
  {
    if (this == &copy)
      return *this;
    x_offset = copy.x_offset;
    y_offset = copy.y_offset;
    height = copy.height;
    width = copy.width;
    return *this;
  }
  virtual ~RegionOfInterest() 
  {
  }
  inline static std::string __s_getDataType() { return std::string("sensor_msgs/RegionOfInterest"); }
  inline static std::string __s_getMD5Sum() { return std::string("878e60591f2679769082130f7aafa371"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# This message is used to specify a region of interest within an image\n"
    "#\n"
    "# When used to specify the ROI setting of the camera when the image was taken,\n"
    "# the height and width fields should either match the height and width\n"
    "# fields for the associated image or be zeroes to indicate that the full image\n"
    "# was captured\n"
    "\n"
    "uint32 x_offset  #Leftmost pixel of the ROI (0 if the left edge of the image is included in the ROI)\n"
    "uint32 y_offset  #Topmost pixel of the ROI (0 if the top edge of the image is included in the ROI)\n"
    "uint32 height    #Height of ROI\n"
    "uint32 width     #Width of ROI\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += 4; // x_offset
    __l += 4; // y_offset
    __l += 4; // height
    __l += 4; // width
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    SROS_SERIALIZE_PRIMITIVE(write_ptr, x_offset);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, y_offset);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, height);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, width);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, x_offset);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, y_offset);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, height);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, width);
    return read_ptr;
  }
};

typedef boost::shared_ptr<RegionOfInterest> RegionOfInterestPtr;
typedef boost::shared_ptr<RegionOfInterest const> RegionOfInterestConstPtr;


}

#endif
