# autogenerated by genmsg_py from CameraInfo.msg. Do not edit.
import roslib.message
import struct

import roslib.msg
import sensor_msgs.msg

class CameraInfo(roslib.message.Message):
  _md5sum = "1b5cf7f984c229b6141ceb3a955aa18f"
  _type = "sensor_msgs/CameraInfo"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """# This message defines meta information for a camera. It should be in a
# camera namespace and accompanied by up to 5 image topics named:
# 
# image_raw, image, image_color, image_rect, and image_rect_color
#
# The meaning of the camera parameters are described in detail at
# http://pr.willowgarage.com/wiki/Camera_Calibration.

##########################
# Image acquisition info #
##########################

# Time of image acquisition, camera coordinate frame ID
Header header        # Header timestamp should be acquisition time of image
                     # Header frame_id should be optical frame of camera
                     # origin of frame should be optical center of camera
                     # +x should point to the right in the image
                     # +y should point down in the image
                     # +z should point into to plane of the image

# Camera resolution in pixels
uint32 height
uint32 width

# Region of interest (subwindow of full camera resolution), if applicable
RegionOfInterest roi

##########################################
# Internal parameters                    #
# Used for warping to:                   #
#  1. An undistorted image (just D and K)#
#  2. A rectified image (D, K, R)        #
# Users should not normally need these   #
##########################################

# Distortion parameters: k1, k2, t1, t2, k3
# These model radial and tangential distortion of the camera.
float64[5]  D # 5x1 vector

# Intrinsic camera matrix for the raw (distorted) images
# Projects 3D points in the camera coordinate frame to 2D pixel
# coordinates using the focal lengths (fx, fy) and principal point
# (cx, cy):
#     [fx  0 cx]
# K = [ 0 fy cy]
#     [ 0  0  1]

float64[9]  K # 3x3 row-major matrix


# Rectification matrix (stereo cameras only)
# A homography which takes an image to the ideal stereo image plane
# so that epipolar lines in both stereo images are parallel.
float64[9]  R # 3x3 row-major matrix

######################################
# Projection/camera matrix           #
# This is a 3x4 projection matrix    #
#   for going from 3D to 2D coords   #
######################################

# Projection/camera matrix
# By convention, this matrix specifies the intrinsic (camera)
#   matrix of the processed (rectified) image.
# Upper 3x3 portion is the normal camera intrinsic matrix for
#   the rectified image
# Projects 3D points in the camera coordinate frame to 2D pixel
# coordinates using the focal lengths (fx, fy) and principal point
# (cx, cy):
#              [fx  0 cx]
# P[1:3,1:3] = [ 0 fy cy]
#              [ 0  0  1]
# For the right camera of a stereo pair, P[4,1] is the position
#  of the right camera center in the left camera's frame, times
#  the focal length fx.
# 
# Given a 3D point q=[XYZ]^T in the left camera frame, the projection
#  of the point onto the image is given by [uvw]^T = Pq, with x=u/w and y=v/w.
#  This holds for both left and right images of a stereo pair.  
#  For monocular cameras and the left image of a stereo pair, P[4,1] is always 0.

float64[12] P # 3x4 row-major matrix

================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: sensor_msgs/RegionOfInterest
# This message is used to specify a region of interest within an image
#
# When used to specify the ROI setting of the camera when the image was taken,
# the height and width fields should either match the height and width
# fields for the associated image or be zeroes to indicate that the full image
# was captured

uint32 x_offset  #Leftmost pixel of the ROI (0 if the left edge of the image is included in the ROI)
uint32 y_offset  #Topmost pixel of the ROI (0 if the top edge of the image is included in the ROI)
uint32 height    #Height of ROI
uint32 width     #Width of ROI

"""
  __slots__ = ['header','height','width','roi','D','K','R','P']
  _slot_types = ['Header','uint32','uint32','sensor_msgs/RegionOfInterest','float64[5]','float64[9]','float64[9]','float64[12]']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   header,height,width,roi,D,K,R,P
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(CameraInfo, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.height is None:
        self.height = 0
      if self.width is None:
        self.width = 0
      if self.roi is None:
        self.roi = sensor_msgs.msg.RegionOfInterest()
      if self.D is None:
        self.D = [0.,0.,0.,0.,0.]
      if self.K is None:
        self.K = [0.,0.,0.,0.,0.,0.,0.,0.,0.]
      if self.R is None:
        self.R = [0.,0.,0.,0.,0.,0.,0.,0.,0.]
      if self.P is None:
        self.P = [0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.]
    else:
      self.header = roslib.msg._Header.Header()
      self.height = 0
      self.width = 0
      self.roi = sensor_msgs.msg.RegionOfInterest()
      self.D = [0.,0.,0.,0.,0.]
      self.K = [0.,0.,0.,0.,0.,0.,0.,0.,0.]
      self.R = [0.,0.,0.,0.,0.,0.,0.,0.,0.]
      self.P = [0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.]

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      buff.write(struct.pack('<6I', self.height, self.width, self.roi.x_offset, self.roi.y_offset, self.roi.height, self.roi.width))
      #serialize self.D
      buff.write(struct.pack('<5d', *self.D))
      #serialize self.K
      buff.write(struct.pack('<9d', *self.K))
      #serialize self.R
      buff.write(struct.pack('<9d', *self.R))
      #serialize self.P
      buff.write(struct.pack('<12d', *self.P))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.roi is None:
        self.roi = sensor_msgs.msg.RegionOfInterest()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 24
      (self.height, self.width, self.roi.x_offset, self.roi.y_offset, self.roi.height, self.roi.width,) = struct.unpack('<6I',str[start:end])
      #deserialize self.D
      start = end
      end += 40
      self.D = struct.unpack('<5d',str[start:end])
      #deserialize self.K
      start = end
      end += 72
      self.K = struct.unpack('<9d',str[start:end])
      #deserialize self.R
      start = end
      end += 72
      self.R = struct.unpack('<9d',str[start:end])
      #deserialize self.P
      start = end
      end += 96
      self.P = struct.unpack('<12d',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      buff.write(struct.pack('<6I', self.height, self.width, self.roi.x_offset, self.roi.y_offset, self.roi.height, self.roi.width))
      #serialize self.D
      buff.write(self.D.tostring())
      #serialize self.K
      buff.write(self.K.tostring())
      #serialize self.R
      buff.write(self.R.tostring())
      #serialize self.P
      buff.write(self.P.tostring())
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.roi is None:
        self.roi = sensor_msgs.msg.RegionOfInterest()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 24
      (self.height, self.width, self.roi.x_offset, self.roi.y_offset, self.roi.height, self.roi.width,) = struct.unpack('<6I',str[start:end])
      #deserialize self.D
      start = end
      end += 40
      self.D = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=5)
      #deserialize self.K
      start = end
      end += 72
      self.K = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=9)
      #deserialize self.R
      start = end
      end += 72
      self.R = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=9)
      #deserialize self.P
      start = end
      end += 96
      self.P = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=12)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

