# autogenerated by genmsg_py from Image.msg. Do not edit.
import roslib.message
import struct

import roslib.msg

class Image(roslib.message.Message):
  _md5sum = "060021388200f6f0f447d0fcd9c64743"
  _type = "sensor_msgs/Image"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """# This message contains an uncompressed image
# (0, 0) is at top-left corner of image
#

Header header        # Header timestamp should be acquisition time of image
                     # Header frame_id should be optical frame of camera
                     # origin of frame should be optical center of cameara
                     # +x should point to the right in the image
                     # +y should point down in the image
                     # +z should point into to plane of the image
                     # If the frame_id here and the frame_id of the CameraInfo
                     # message associated with the image conflict
                     # the behavior is undefined

uint32 height         # image height, that is, number of rows
uint32 width          # image width, that is, number of columns

# The legal values for encoding are in file src/image_encodings.cpp
# If you want to standardize a new string format, join
# ros-users@lists.sourceforge.net and send an email proposing a new encoding.

string encoding       # Encoding of pixels -- channel meaning, ordering, size
                      # taken from the list of strings in src/image_encodings.cpp

uint8 is_bigendian    # is this data bigendian?
uint32 step           # Full row length in bytes
uint8[] data          # actual matrix data, size is (step * rows)

================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

"""
  __slots__ = ['header','height','width','encoding','is_bigendian','step','data']
  _slot_types = ['Header','uint32','uint32','string','uint8','uint32','uint8[]']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   header,height,width,encoding,is_bigendian,step,data
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(Image, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.height is None:
        self.height = 0
      if self.width is None:
        self.width = 0
      if self.encoding is None:
        self.encoding = ''
      if self.is_bigendian is None:
        self.is_bigendian = 0
      if self.step is None:
        self.step = 0
      if self.data is None:
        self.data = ''
    else:
      self.header = roslib.msg._Header.Header()
      self.height = 0
      self.width = 0
      self.encoding = ''
      self.is_bigendian = 0
      self.step = 0
      self.data = ''

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      buff.write(struct.pack('<2I', self.height, self.width))
      length = len(self.encoding)
      #serialize self.encoding
      buff.write(struct.pack('<I%ss'%length, length, self.encoding))
      buff.write(struct.pack('<BI', self.is_bigendian, self.step))
      length = len(self.data)
      #serialize self.data
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(self.data) in [list, tuple]:
        buff.write(struct.pack('<I%sB'%length, length, *self.data))
      else:
        buff.write(struct.pack('<I%ss'%length, length, self.data))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 8
      (self.height, self.width,) = struct.unpack('<2I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.encoding
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.encoding,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 5
      (self.is_bigendian, self.step,) = struct.unpack('<BI',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.data
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.data,) = struct.unpack(pattern, str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      buff.write(struct.pack('<2I', self.height, self.width))
      length = len(self.encoding)
      #serialize self.encoding
      buff.write(struct.pack('<I%ss'%length, length, self.encoding))
      buff.write(struct.pack('<BI', self.is_bigendian, self.step))
      length = len(self.data)
      #serialize self.data
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(self.data) in [list, tuple]:
        buff.write(struct.pack('<I%sB'%length, length, *self.data))
      else:
        buff.write(struct.pack('<I%ss'%length, length, self.data))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 8
      (self.height, self.width,) = struct.unpack('<2I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.encoding
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.encoding,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 5
      (self.is_bigendian, self.step,) = struct.unpack('<BI',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.data
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.data,) = struct.unpack(pattern, str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

