# autogenerated by genmsg_py from Imu.msg. Do not edit.
import roslib.message
import struct

import geometry_msgs.msg
import roslib.msg

class Imu(roslib.message.Message):
  _md5sum = "6a62c6daae103f4ff57a132d6f95cec2"
  _type = "sensor_msgs/Imu"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """# This is a message to hold data from an IMU (Inertial Measurement Unit)
#
# Accelerations should be in m/s^2 (not in g's), and rotational velocity should be in rad/sec
#
# If the covariance of the measurement is known, it should be filled in (if all you know is the variance of each measurement, e.g. from the datasheet, just put those along the diagonal)
# A covariance matrix of all zeros will be interpreted as "covariance unknown", and to use the data a covariance will have to be assumed or gotten from some other source
#
# If you have no estimate for one of the data elements (e.g. your IMU doesn't produce an orientation estimate), please set element 0 of the associated covariance matrix to -1
# If you are interpreting this message, please check for a value of -1 in the first element of each covariance matrix, and disregard the associated estimate.

Header header

geometry_msgs/Quaternion orientation
float64[9] orientation_covariance # Row major about x, y, z axes

geometry_msgs/Vector3 angular_velocity
float64[9] angular_velocity_covariance # Row major about x, y, z axes

geometry_msgs/Vector3 linear_acceleration
float64[9] linear_acceleration_covariance # Row major x, y z 

================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
"""
  __slots__ = ['header','orientation','orientation_covariance','angular_velocity','angular_velocity_covariance','linear_acceleration','linear_acceleration_covariance']
  _slot_types = ['Header','geometry_msgs/Quaternion','float64[9]','geometry_msgs/Vector3','float64[9]','geometry_msgs/Vector3','float64[9]']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   header,orientation,orientation_covariance,angular_velocity,angular_velocity_covariance,linear_acceleration,linear_acceleration_covariance
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(Imu, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.orientation is None:
        self.orientation = geometry_msgs.msg.Quaternion()
      if self.orientation_covariance is None:
        self.orientation_covariance = [0.,0.,0.,0.,0.,0.,0.,0.,0.]
      if self.angular_velocity is None:
        self.angular_velocity = geometry_msgs.msg.Vector3()
      if self.angular_velocity_covariance is None:
        self.angular_velocity_covariance = [0.,0.,0.,0.,0.,0.,0.,0.,0.]
      if self.linear_acceleration is None:
        self.linear_acceleration = geometry_msgs.msg.Vector3()
      if self.linear_acceleration_covariance is None:
        self.linear_acceleration_covariance = [0.,0.,0.,0.,0.,0.,0.,0.,0.]
    else:
      self.header = roslib.msg._Header.Header()
      self.orientation = geometry_msgs.msg.Quaternion()
      self.orientation_covariance = [0.,0.,0.,0.,0.,0.,0.,0.,0.]
      self.angular_velocity = geometry_msgs.msg.Vector3()
      self.angular_velocity_covariance = [0.,0.,0.,0.,0.,0.,0.,0.,0.]
      self.linear_acceleration = geometry_msgs.msg.Vector3()
      self.linear_acceleration_covariance = [0.,0.,0.,0.,0.,0.,0.,0.,0.]

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      buff.write(struct.pack('<4d', self.orientation.x, self.orientation.y, self.orientation.z, self.orientation.w))
      #serialize self.orientation_covariance
      buff.write(struct.pack('<9d', *self.orientation_covariance))
      buff.write(struct.pack('<3d', self.angular_velocity.x, self.angular_velocity.y, self.angular_velocity.z))
      #serialize self.angular_velocity_covariance
      buff.write(struct.pack('<9d', *self.angular_velocity_covariance))
      buff.write(struct.pack('<3d', self.linear_acceleration.x, self.linear_acceleration.y, self.linear_acceleration.z))
      #serialize self.linear_acceleration_covariance
      buff.write(struct.pack('<9d', *self.linear_acceleration_covariance))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.orientation is None:
        self.orientation = geometry_msgs.msg.Quaternion()
      if self.angular_velocity is None:
        self.angular_velocity = geometry_msgs.msg.Vector3()
      if self.linear_acceleration is None:
        self.linear_acceleration = geometry_msgs.msg.Vector3()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 32
      (self.orientation.x, self.orientation.y, self.orientation.z, self.orientation.w,) = struct.unpack('<4d',str[start:end])
      #deserialize self.orientation_covariance
      start = end
      end += 72
      self.orientation_covariance = struct.unpack('<9d',str[start:end])
      start = end
      end += 24
      (self.angular_velocity.x, self.angular_velocity.y, self.angular_velocity.z,) = struct.unpack('<3d',str[start:end])
      #deserialize self.angular_velocity_covariance
      start = end
      end += 72
      self.angular_velocity_covariance = struct.unpack('<9d',str[start:end])
      start = end
      end += 24
      (self.linear_acceleration.x, self.linear_acceleration.y, self.linear_acceleration.z,) = struct.unpack('<3d',str[start:end])
      #deserialize self.linear_acceleration_covariance
      start = end
      end += 72
      self.linear_acceleration_covariance = struct.unpack('<9d',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      buff.write(struct.pack('<4d', self.orientation.x, self.orientation.y, self.orientation.z, self.orientation.w))
      #serialize self.orientation_covariance
      buff.write(self.orientation_covariance.tostring())
      buff.write(struct.pack('<3d', self.angular_velocity.x, self.angular_velocity.y, self.angular_velocity.z))
      #serialize self.angular_velocity_covariance
      buff.write(self.angular_velocity_covariance.tostring())
      buff.write(struct.pack('<3d', self.linear_acceleration.x, self.linear_acceleration.y, self.linear_acceleration.z))
      #serialize self.linear_acceleration_covariance
      buff.write(self.linear_acceleration_covariance.tostring())
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.orientation is None:
        self.orientation = geometry_msgs.msg.Quaternion()
      if self.angular_velocity is None:
        self.angular_velocity = geometry_msgs.msg.Vector3()
      if self.linear_acceleration is None:
        self.linear_acceleration = geometry_msgs.msg.Vector3()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 32
      (self.orientation.x, self.orientation.y, self.orientation.z, self.orientation.w,) = struct.unpack('<4d',str[start:end])
      #deserialize self.orientation_covariance
      start = end
      end += 72
      self.orientation_covariance = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=9)
      start = end
      end += 24
      (self.angular_velocity.x, self.angular_velocity.y, self.angular_velocity.z,) = struct.unpack('<3d',str[start:end])
      #deserialize self.angular_velocity_covariance
      start = end
      end += 72
      self.angular_velocity_covariance = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=9)
      start = end
      end += 24
      (self.linear_acceleration.x, self.linear_acceleration.y, self.linear_acceleration.z,) = struct.unpack('<3d',str[start:end])
      #deserialize self.linear_acceleration_covariance
      start = end
      end += 72
      self.linear_acceleration_covariance = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=9)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

