# autogenerated by genmsg_py from PointCloud.msg. Do not edit.
import roslib.message
import struct

import geometry_msgs.msg
import roslib.msg
import sensor_msgs.msg

class PointCloud(roslib.message.Message):
  _md5sum = "d8e9c3f5afbdd8a130fd1d2763945fca"
  _type = "sensor_msgs/PointCloud"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """#This message holds a collection of 3d points, plus optional additional information about each point.
#Each Point32 should be interpreted as a 3d point in the frame given in the header

Header header
geometry_msgs/Point32[] points  #Array of 3d points
ChannelFloat32[] channels       #Each channel should have the same number of elements as points array, and the data in each channel should correspond 1:1 with each point

================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Point32
# This contains the position of a point in free space(with 32 bits of precision).
# It is recommeded to use Point wherever possible instead of Point32.  
# 
# This recommendation is to promote interoperability.  
#
# This message is designed to take up less space when sending
# lots of points at once, as in the case of a PointCloud.  

float32 x
float32 y
float32 z
================================================================================
MSG: sensor_msgs/ChannelFloat32
#This message is used by the PointCloud message to hold optional data associated with each point in the cloud
#The length of the values array should be the same as the length of the points array in the PointCloud, and each value should be associated with the corresponding point

string name       #channel name should give semantics of the channel (e.g. "intensity" instead of "value")
float32[] values  #values array should have same number of elements as the associated PointCloud

"""
  __slots__ = ['header','points','channels']
  _slot_types = ['Header','geometry_msgs/Point32[]','sensor_msgs/ChannelFloat32[]']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   header,points,channels
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(PointCloud, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.points is None:
        self.points = []
      if self.channels is None:
        self.channels = []
    else:
      self.header = roslib.msg._Header.Header()
      self.points = []
      self.channels = []

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      #serialize self.points
      length = len(self.points)
      buff.write(struct.pack('<I', length))
      for val1 in self.points:
        buff.write(struct.pack('<3f', val1.x, val1.y, val1.z))
      #serialize self.channels
      length = len(self.channels)
      buff.write(struct.pack('<I', length))
      for val1 in self.channels:
        length = len(val1.name)
        #serialize val1.name
        buff.write(struct.pack('<I%ss'%length, length, val1.name))
        #serialize val1.values
        length = len(val1.values)
        buff.write(struct.pack('<I', length))
        pattern = '<%sf'%length
        buff.write(struct.pack(pattern, *val1.values))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      #deserialize self.points
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.points = []
      for i in xrange(0, length):
        val1 = geometry_msgs.msg.Point32()
        start = end
        end += 12
        (val1.x, val1.y, val1.z,) = struct.unpack('<3f',str[start:end])
        self.points.append(val1)
      #deserialize self.channels
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.channels = []
      for i in xrange(0, length):
        val1 = sensor_msgs.msg.ChannelFloat32()
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.name,) = struct.unpack(pattern, str[start:end])
        #deserialize val1.values
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.values = struct.unpack(pattern, str[start:end])
        self.channels.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      #serialize self.points
      length = len(self.points)
      buff.write(struct.pack('<I', length))
      for val1 in self.points:
        buff.write(struct.pack('<3f', val1.x, val1.y, val1.z))
      #serialize self.channels
      length = len(self.channels)
      buff.write(struct.pack('<I', length))
      for val1 in self.channels:
        length = len(val1.name)
        #serialize val1.name
        buff.write(struct.pack('<I%ss'%length, length, val1.name))
        #serialize val1.values
        length = len(val1.values)
        buff.write(struct.pack('<I', length))
        pattern = '<%sf'%length
        buff.write(val1.values.tostring())
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      #deserialize self.points
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.points = []
      for i in xrange(0, length):
        val1 = geometry_msgs.msg.Point32()
        start = end
        end += 12
        (val1.x, val1.y, val1.z,) = struct.unpack('<3f',str[start:end])
        self.points.append(val1)
      #deserialize self.channels
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.channels = []
      for i in xrange(0, length):
        val1 = sensor_msgs.msg.ChannelFloat32()
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.name,) = struct.unpack(pattern, str[start:end])
        #deserialize val1.values
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.values = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
        self.channels.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

