# autogenerated by genmsg_py from SetCameraInfoRequest.msg. Do not edit.
import roslib.message
import struct

import roslib.msg
import sensor_msgs.msg

class SetCameraInfoRequest(roslib.message.Message):
  _md5sum = "26eaebb51c55ae49e67f4224751388e8"
  _type = "sensor_msgs/SetCameraInfoRequest"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """







sensor_msgs/CameraInfo camera_info

================================================================================
MSG: sensor_msgs/CameraInfo
# This message defines meta information for a camera. It should be in a
# camera namespace and accompanied by up to 5 image topics named:
# 
# image_raw, image, image_color, image_rect, and image_rect_color
#
# The meaning of the camera parameters are described in detail at
# http://pr.willowgarage.com/wiki/Camera_Calibration.

##########################
# Image acquisition info #
##########################

# Time of image acquisition, camera coordinate frame ID
Header header        # Header timestamp should be acquisition time of image
                     # Header frame_id should be optical frame of camera
                     # origin of frame should be optical center of camera
                     # +x should point to the right in the image
                     # +y should point down in the image
                     # +z should point into to plane of the image

# Camera resolution in pixels
uint32 height
uint32 width

# Region of interest (subwindow of full camera resolution), if applicable
RegionOfInterest roi

##########################################
# Internal parameters                    #
# Used for warping to:                   #
#  1. An undistorted image (just D and K)#
#  2. A rectified image (D, K, R)        #
# Users should not normally need these   #
##########################################

# Distortion parameters: k1, k2, t1, t2, k3
# These model radial and tangential distortion of the camera.
float64[5]  D # 5x1 vector

# Intrinsic camera matrix for the raw (distorted) images
# Projects 3D points in the camera coordinate frame to 2D pixel
# coordinates using the focal lengths (fx, fy) and principal point
# (cx, cy):
#     [fx  0 cx]
# K = [ 0 fy cy]
#     [ 0  0  1]

float64[9]  K # 3x3 row-major matrix


# Rectification matrix (stereo cameras only)
# A homography which takes an image to the ideal stereo image plane
# so that epipolar lines in both stereo images are parallel.
float64[9]  R # 3x3 row-major matrix

######################################
# Projection/camera matrix           #
# This is a 3x4 projection matrix    #
#   for going from 3D to 2D coords   #
######################################

# Projection/camera matrix
# By convention, this matrix specifies the intrinsic (camera)
#   matrix of the processed (rectified) image.
# Upper 3x3 portion is the normal camera intrinsic matrix for
#   the rectified image
# Projects 3D points in the camera coordinate frame to 2D pixel
# coordinates using the focal lengths (fx, fy) and principal point
# (cx, cy):
#              [fx  0 cx]
# P[1:3,1:3] = [ 0 fy cy]
#              [ 0  0  1]
# For the right camera of a stereo pair, P[4,1] is the position
#  of the right camera center in the left camera's frame, times
#  the focal length fx.
# 
# Given a 3D point q=[XYZ]^T in the left camera frame, the projection
#  of the point onto the image is given by [uvw]^T = Pq, with x=u/w and y=v/w.
#  This holds for both left and right images of a stereo pair.  
#  For monocular cameras and the left image of a stereo pair, P[4,1] is always 0.

float64[12] P # 3x4 row-major matrix

================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: sensor_msgs/RegionOfInterest
# This message is used to specify a region of interest within an image
#
# When used to specify the ROI setting of the camera when the image was taken,
# the height and width fields should either match the height and width
# fields for the associated image or be zeroes to indicate that the full image
# was captured

uint32 x_offset  #Leftmost pixel of the ROI (0 if the left edge of the image is included in the ROI)
uint32 y_offset  #Topmost pixel of the ROI (0 if the top edge of the image is included in the ROI)
uint32 height    #Height of ROI
uint32 width     #Width of ROI

"""
  __slots__ = ['camera_info']
  _slot_types = ['sensor_msgs/CameraInfo']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   camera_info
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(SetCameraInfoRequest, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.camera_info is None:
        self.camera_info = sensor_msgs.msg.CameraInfo()
    else:
      self.camera_info = sensor_msgs.msg.CameraInfo()

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      buff.write(struct.pack('<3I', self.camera_info.header.seq, self.camera_info.header.stamp.secs, self.camera_info.header.stamp.nsecs))
      length = len(self.camera_info.header.frame_id)
      #serialize self.camera_info.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.camera_info.header.frame_id))
      buff.write(struct.pack('<6I', self.camera_info.height, self.camera_info.width, self.camera_info.roi.x_offset, self.camera_info.roi.y_offset, self.camera_info.roi.height, self.camera_info.roi.width))
      #serialize self.camera_info.D
      buff.write(struct.pack('<5d', *self.camera_info.D))
      #serialize self.camera_info.K
      buff.write(struct.pack('<9d', *self.camera_info.K))
      #serialize self.camera_info.R
      buff.write(struct.pack('<9d', *self.camera_info.R))
      #serialize self.camera_info.P
      buff.write(struct.pack('<12d', *self.camera_info.P))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.camera_info is None:
        self.camera_info = sensor_msgs.msg.CameraInfo()
      end = 0
      start = end
      end += 12
      (self.camera_info.header.seq, self.camera_info.header.stamp.secs, self.camera_info.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.camera_info.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.camera_info.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 24
      (self.camera_info.height, self.camera_info.width, self.camera_info.roi.x_offset, self.camera_info.roi.y_offset, self.camera_info.roi.height, self.camera_info.roi.width,) = struct.unpack('<6I',str[start:end])
      #deserialize self.camera_info.D
      start = end
      end += 40
      self.camera_info.D = struct.unpack('<5d',str[start:end])
      #deserialize self.camera_info.K
      start = end
      end += 72
      self.camera_info.K = struct.unpack('<9d',str[start:end])
      #deserialize self.camera_info.R
      start = end
      end += 72
      self.camera_info.R = struct.unpack('<9d',str[start:end])
      #deserialize self.camera_info.P
      start = end
      end += 96
      self.camera_info.P = struct.unpack('<12d',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      buff.write(struct.pack('<3I', self.camera_info.header.seq, self.camera_info.header.stamp.secs, self.camera_info.header.stamp.nsecs))
      length = len(self.camera_info.header.frame_id)
      #serialize self.camera_info.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.camera_info.header.frame_id))
      buff.write(struct.pack('<6I', self.camera_info.height, self.camera_info.width, self.camera_info.roi.x_offset, self.camera_info.roi.y_offset, self.camera_info.roi.height, self.camera_info.roi.width))
      #serialize self.camera_info.D
      buff.write(self.camera_info.D.tostring())
      #serialize self.camera_info.K
      buff.write(self.camera_info.K.tostring())
      #serialize self.camera_info.R
      buff.write(self.camera_info.R.tostring())
      #serialize self.camera_info.P
      buff.write(self.camera_info.P.tostring())
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.camera_info is None:
        self.camera_info = sensor_msgs.msg.CameraInfo()
      end = 0
      start = end
      end += 12
      (self.camera_info.header.seq, self.camera_info.header.stamp.secs, self.camera_info.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.camera_info.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.camera_info.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 24
      (self.camera_info.height, self.camera_info.width, self.camera_info.roi.x_offset, self.camera_info.roi.y_offset, self.camera_info.roi.height, self.camera_info.roi.width,) = struct.unpack('<6I',str[start:end])
      #deserialize self.camera_info.D
      start = end
      end += 40
      self.camera_info.D = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=5)
      #deserialize self.camera_info.K
      start = end
      end += 72
      self.camera_info.K = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=9)
      #deserialize self.camera_info.R
      start = end
      end += 72
      self.camera_info.R = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=9)
      #deserialize self.camera_info.P
      start = end
      end += 96
      self.camera_info.P = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=12)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

# autogenerated by genmsg_py from SetCameraInfoResponse.msg. Do not edit.
import roslib.message
import struct


class SetCameraInfoResponse(roslib.message.Message):
  _md5sum = "2ec6f3eff0161f4257b808b12bc830c2"
  _type = "sensor_msgs/SetCameraInfoResponse"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """bool success
string status_message


"""
  __slots__ = ['success','status_message']
  _slot_types = ['bool','string']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   success,status_message
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(SetCameraInfoResponse, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.success is None:
        self.success = False
      if self.status_message is None:
        self.status_message = ''
    else:
      self.success = False
      self.status_message = ''

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      buff.write(struct.pack('<B', self.success))
      length = len(self.status_message)
      #serialize self.status_message
      buff.write(struct.pack('<I%ss'%length, length, self.status_message))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      end = 0
      start = end
      end += 1
      (self.success,) = struct.unpack('<B',str[start:end])
      self.success = bool(self.success)
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.status_message
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.status_message,) = struct.unpack(pattern, str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      buff.write(struct.pack('<B', self.success))
      length = len(self.status_message)
      #serialize self.status_message
      buff.write(struct.pack('<I%ss'%length, length, self.status_message))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      end = 0
      start = end
      end += 1
      (self.success,) = struct.unpack('<B',str[start:end])
      self.success = bool(self.success)
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.status_message
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.status_message,) = struct.unpack(pattern, str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

class SetCameraInfo(roslib.message.ServiceDefinition):
  _type          = 'sensor_msgs/SetCameraInfo'
  _md5sum = 'a55592a696fd7c645dbeaddc896aa783'
  _request_class  = SetCameraInfoRequest
  _response_class = SetCameraInfoResponse
