/* auto-generated by gensrv_cpp from /opt/ros/boxturtle/stacks/common_msgs/sensor_msgs/srv/SetCameraInfo.srv.  Do not edit! */
#ifndef SRV_SENSOR_MSGS_SETCAMERAINFO_H
#define SRV_SENSOR_MSGS_SETCAMERAINFO_H

#include <string>
#include <cstring>
#include <vector>
#include <map>
#include "ros/message.h"
#include "ros/time.h"

#include "roslib/Header.h"
#include "sensor_msgs/RegionOfInterest.h"
#include "sensor_msgs/CameraInfo.h"

namespace sensor_msgs
{

struct SetCameraInfo
{

inline static std::string getDataType() { return "sensor_msgs/SetCameraInfo"; }
inline static std::string getMD5Sum() { return "a55592a696fd7c645dbeaddc896aa783"; }

//! \htmlinclude Request.msg.html

class Request : public ros::Message
{
public:
  typedef boost::shared_ptr<Request> Ptr;
  typedef boost::shared_ptr<Request const> ConstPtr;

  typedef sensor_msgs::CameraInfo _camera_info_type;

  sensor_msgs::CameraInfo camera_info;

  Request() : ros::Message()
  {
  }
  Request(const Request &copy) : ros::Message(),
    camera_info(copy.camera_info)
  {
    (void)copy;
  }
  Request &operator =(const Request &copy)
  {
    if (this == &copy)
      return *this;
    camera_info = copy.camera_info;
    return *this;
  }
  virtual ~Request() 
  {
  }
  inline static std::string __s_getDataType() { return std::string("sensor_msgs/SetCameraInfoRequest"); }
  inline static std::string __s_getMD5Sum() { return std::string(""); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# This service requests that a camera stores the given CameraInfo \n"
    "# as that camera's calibration information.\n"
    "#\n"
    "# The width and height in the camera_info field should match what the\n"
    "# camera is currently outputting on its camera_info topic, and the camera\n"
    "# will assume that the region of the imager that is being referred to is\n"
    "# the region that the camera is currently capturing.\n"
    "\n"
    "sensor_msgs/CameraInfo camera_info # The camera_info to store\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline static std::string __s_getServerMD5Sum() { return std::string("a55592a696fd7c645dbeaddc896aa783"); }
  inline virtual const std::string __getServerMD5Sum() const { return __s_getServerMD5Sum(); }
  inline static std::string __s_getServiceDataType() { return std::string("sensor_msgs/SetCameraInfo"); }
  inline virtual const std::string __getServiceDataType() const { return __s_getServiceDataType(); }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += camera_info.serializationLength(); // camera_info
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    write_ptr = camera_info.serialize(write_ptr, seq);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    read_ptr = camera_info.deserialize(read_ptr);
    return read_ptr;
  }
};

typedef boost::shared_ptr<Request> RequestPtr;
typedef boost::shared_ptr<Request const> RequestConstPtr;

//! \htmlinclude Response.msg.html

class Response : public ros::Message
{
public:
  typedef boost::shared_ptr<Response> Ptr;
  typedef boost::shared_ptr<Response const> ConstPtr;

  typedef uint8_t _success_type;
  typedef std::string _status_message_type;

  uint8_t success;
  std::string status_message;

  Response() : ros::Message(),
    success(0)
  {
  }
  Response(const Response &copy) : ros::Message(),
    success(copy.success),
    status_message(copy.status_message)
  {
    (void)copy;
  }
  Response &operator =(const Response &copy)
  {
    if (this == &copy)
      return *this;
    success = copy.success;
    status_message = copy.status_message;
    return *this;
  }
  virtual ~Response() 
  {
  }
  inline static std::string __s_getDataType() { return std::string("sensor_msgs/SetCameraInfoResponse"); }
  inline static std::string __s_getMD5Sum() { return std::string(""); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "bool success          # True if the call succeeded\n"
    "string status_message # Used to give details about success\n"
    "\n"
    "================================================================================\n"
    "MSG: sensor_msgs/CameraInfo\n"
    "# This message defines meta information for a camera. It should be in a\n"
    "# camera namespace and accompanied by up to 5 image topics named:\n"
    "# \n"
    "# image_raw, image, image_color, image_rect, and image_rect_color\n"
    "#\n"
    "# The meaning of the camera parameters are described in detail at\n"
    "# http://pr.willowgarage.com/wiki/Camera_Calibration.\n"
    "\n"
    "##########################\n"
    "# Image acquisition info #\n"
    "##########################\n"
    "\n"
    "# Time of image acquisition, camera coordinate frame ID\n"
    "Header header        # Header timestamp should be acquisition time of image\n"
    "                     # Header frame_id should be optical frame of camera\n"
    "                     # origin of frame should be optical center of camera\n"
    "                     # +x should point to the right in the image\n"
    "                     # +y should point down in the image\n"
    "                     # +z should point into to plane of the image\n"
    "\n"
    "# Camera resolution in pixels\n"
    "uint32 height\n"
    "uint32 width\n"
    "\n"
    "# Region of interest (subwindow of full camera resolution), if applicable\n"
    "RegionOfInterest roi\n"
    "\n"
    "##########################################\n"
    "# Internal parameters                    #\n"
    "# Used for warping to:                   #\n"
    "#  1. An undistorted image (just D and K)#\n"
    "#  2. A rectified image (D, K, R)        #\n"
    "# Users should not normally need these   #\n"
    "##########################################\n"
    "\n"
    "# Distortion parameters: k1, k2, t1, t2, k3\n"
    "# These model radial and tangential distortion of the camera.\n"
    "float64[5]  D # 5x1 vector\n"
    "\n"
    "# Intrinsic camera matrix for the raw (distorted) images\n"
    "# Projects 3D points in the camera coordinate frame to 2D pixel\n"
    "# coordinates using the focal lengths (fx, fy) and principal point\n"
    "# (cx, cy):\n"
    "#     [fx  0 cx]\n"
    "# K = [ 0 fy cy]\n"
    "#     [ 0  0  1]\n"
    "\n"
    "float64[9]  K # 3x3 row-major matrix\n"
    "\n"
    "\n"
    "# Rectification matrix (stereo cameras only)\n"
    "# A homography which takes an image to the ideal stereo image plane\n"
    "# so that epipolar lines in both stereo images are parallel.\n"
    "float64[9]  R # 3x3 row-major matrix\n"
    "\n"
    "######################################\n"
    "# Projection/camera matrix           #\n"
    "# This is a 3x4 projection matrix    #\n"
    "#   for going from 3D to 2D coords   #\n"
    "######################################\n"
    "\n"
    "# Projection/camera matrix\n"
    "# By convention, this matrix specifies the intrinsic (camera)\n"
    "#   matrix of the processed (rectified) image.\n"
    "# Upper 3x3 portion is the normal camera intrinsic matrix for\n"
    "#   the rectified image\n"
    "# Projects 3D points in the camera coordinate frame to 2D pixel\n"
    "# coordinates using the focal lengths (fx, fy) and principal point\n"
    "# (cx, cy):\n"
    "#              [fx  0 cx]\n"
    "# P[1:3,1:3] = [ 0 fy cy]\n"
    "#              [ 0  0  1]\n"
    "# For the right camera of a stereo pair, P[4,1] is the position\n"
    "#  of the right camera center in the left camera's frame, times\n"
    "#  the focal length fx.\n"
    "# \n"
    "# Given a 3D point q=[XYZ]^T in the left camera frame, the projection\n"
    "#  of the point onto the image is given by [uvw]^T = Pq, with x=u/w and y=v/w.\n"
    "#  This holds for both left and right images of a stereo pair.  \n"
    "#  For monocular cameras and the left image of a stereo pair, P[4,1] is always 0.\n"
    "\n"
    "float64[12] P # 3x4 row-major matrix\n"
    "\n"
    "================================================================================\n"
    "MSG: roslib/Header\n"
    "# Standard metadata for higher-level stamped data types.\n"
    "# This is generally used to communicate timestamped data \n"
    "# in a particular coordinate frame.\n"
    "# \n"
    "# sequence ID: consecutively increasing ID \n"
    "uint32 seq\n"
    "#Two-integer timestamp that is expressed as:\n"
    "# * stamp.secs: seconds (stamp_secs) since epoch\n"
    "# * stamp.nsecs: nanoseconds since stamp_secs\n"
    "# time-handling sugar is provided by the client library\n"
    "time stamp\n"
    "#Frame this data is associated with\n"
    "# 0: no frame\n"
    "# 1: global frame\n"
    "string frame_id\n"
    "\n"
    "================================================================================\n"
    "MSG: sensor_msgs/RegionOfInterest\n"
    "# This message is used to specify a region of interest within an image\n"
    "#\n"
    "# When used to specify the ROI setting of the camera when the image was taken,\n"
    "# the height and width fields should either match the height and width\n"
    "# fields for the associated image or be zeroes to indicate that the full image\n"
    "# was captured\n"
    "\n"
    "uint32 x_offset  #Leftmost pixel of the ROI (0 if the left edge of the image is included in the ROI)\n"
    "uint32 y_offset  #Topmost pixel of the ROI (0 if the top edge of the image is included in the ROI)\n"
    "uint32 height    #Height of ROI\n"
    "uint32 width     #Width of ROI\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline static std::string __s_getServerMD5Sum() { return std::string("a55592a696fd7c645dbeaddc896aa783"); }
  inline virtual const std::string __getServerMD5Sum() const { return __s_getServerMD5Sum(); }
  inline static std::string __s_getServiceDataType() { return std::string("sensor_msgs/SetCameraInfo"); }
  inline virtual const std::string __getServiceDataType() const { return __s_getServiceDataType(); }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += 1; // success
    __l += 4 + status_message.length(); // status_message
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    SROS_SERIALIZE_PRIMITIVE(write_ptr, success);
    unsigned __ros_status_message_len = status_message.length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_status_message_len);
    SROS_SERIALIZE_BUFFER(write_ptr, status_message.c_str(), __ros_status_message_len);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, success);
    unsigned __ros_status_message_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_status_message_len);
    status_message = std::string((const char *)read_ptr, __ros_status_message_len);
    read_ptr += __ros_status_message_len;
    return read_ptr;
  }
};

typedef boost::shared_ptr<Response> ResponsePtr;
typedef boost::shared_ptr<Response const> ResponseConstPtr;

Request request;
Response response;

};

}

#endif
